/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.impl;

import org.cinco.metamodel.ecosystem.domainontology.DomainontologyPackage;

import org.cinco.metamodel.ecosystem.domainontology.channels.ChannelsPackage;

import org.cinco.metamodel.ecosystem.domainontology.channels.impl.ChannelsPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.concepts.ConceptsPackage;

import org.cinco.metamodel.ecosystem.domainontology.concepts.impl.ConceptsPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.contracting.ContractingPackage;

import org.cinco.metamodel.ecosystem.domainontology.contracting.impl.ContractingPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.entities.EntitiesPackage;

import org.cinco.metamodel.ecosystem.domainontology.entities.impl.EntitiesPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.entitykinds.EntitykindsPackage;

import org.cinco.metamodel.ecosystem.domainontology.entitykinds.impl.EntitykindsPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.facilities.FacilitiesPackage;

import org.cinco.metamodel.ecosystem.domainontology.facilities.impl.FacilitiesPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.impl.DomainontologyPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.EcosystemintensionmodelPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.BindableElement;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.BindableFeature;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.BindableProperty;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.BindingSpecification;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.BindingTarget;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.BindingsFactory;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.BindingsPackage;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.ContractualFeatureBinding;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.ContractualFeatureTarget;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.ContractualPropertyBinding;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.ContractualPropertyTarget;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.CooperativeFeatureBinding;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.CooperativeFeatureTarget;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.CooperativePropertyBinding;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.CooperativePropertyTarget;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.ExtraFunctionalFeatureBinding;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.ExtraFunctionalFeatureTarget;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.FeatureBinding;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.FeatureBindingTarget;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.PortBinding;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.PropertyBinding;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.PropertyBindingTarget;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.FeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.contractualfeatures.ContractualfeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.contractualfeatures.impl.ContractualfeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.cooperativefeatures.CooperativefeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.cooperativefeatures.impl.CooperativefeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.extrafunctionalfeatures.ExtrafunctionalfeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.extrafunctionalfeatures.impl.ExtrafunctionalfeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.facilityfeatures.FacilityfeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.facilityfeatures.impl.FacilityfeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.functionalfeatures.FunctionalfeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.functionalfeatures.impl.FunctionalfeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.impl.FeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.impl.EcosystemintensionmodelPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.IntensionsPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.impl.IntensionsPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.PropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.contractualproperties.ContractualpropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.contractualproperties.impl.ContractualpropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.cooperativeproperties.CooperativepropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.cooperativeproperties.impl.CooperativepropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.facilityproperties.FacilitypropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.facilityproperties.impl.FacilitypropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.functionalproperties.FunctionalpropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.functionalproperties.impl.FunctionalpropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.impl.PropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemmodel.EcosystemmodelPackage;

import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.ChoreographiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.ChoreographiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemmodel.impl.EcosystemmodelPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.LifecyclePackage;

import org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.impl.LifecyclePackageImpl;

import org.cinco.metamodel.ecosystem.engineeringmodel.EngineeringmodelPackage;

import org.cinco.metamodel.ecosystem.engineeringmodel.engineeringcapability.EngineeringcapabilityPackage;

import org.cinco.metamodel.ecosystem.engineeringmodel.engineeringcapability.impl.EngineeringcapabilityPackageImpl;

import org.cinco.metamodel.ecosystem.engineeringmodel.engineeringspace.EngineeringspacePackage;

import org.cinco.metamodel.ecosystem.engineeringmodel.engineeringspace.impl.EngineeringspacePackageImpl;

import org.cinco.metamodel.ecosystem.engineeringmodel.impl.EngineeringmodelPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.FoundationsPackage;

import org.cinco.metamodel.ecosystem.foundations.behaviour.BehaviourPackage;

import org.cinco.metamodel.ecosystem.foundations.behaviour.impl.BehaviourPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.impl.FoundationsPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.models.ModelsPackage;

import org.cinco.metamodel.ecosystem.foundations.models.impl.ModelsPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.modeltransformations.ModeltransformationsPackage;

import org.cinco.metamodel.ecosystem.foundations.modeltransformations.impl.ModeltransformationsPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.relationships.RelationshipsPackage;

import org.cinco.metamodel.ecosystem.foundations.relationships.impl.RelationshipsPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.systems.SystemsPackage;

import org.cinco.metamodel.ecosystem.foundations.systems.impl.SystemsPackageImpl;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.KnowledgemanagementmodelPackage;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.impl.KnowledgemanagementmodelPackageImpl;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.RepositoriesPackage;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl.RepositoriesPackageImpl;

import org.cinco.metamodel.ecosystem.seadescription.SeadescriptionPackage;

import org.cinco.metamodel.ecosystem.seadescription.impl.SeadescriptionPackageImpl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class BindingsPackageImpl extends EPackageImpl implements BindingsPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bindingSpecificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyBindingTargetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bindingTargetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bindablePropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bindableElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass featureBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass featureBindingTargetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass portBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass extraFunctionalFeatureTargetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cooperativeFeatureTargetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass contractualFeatureTargetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cooperativePropertyTargetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cooperativeFeatureBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass extraFunctionalFeatureBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass contractualFeatureBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass contractualPropertyTargetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cooperativePropertyBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass contractualPropertyBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bindableFeatureEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.BindingsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private BindingsPackageImpl() {
		super(eNS_URI, BindingsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link BindingsPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static BindingsPackage init() {
		if (isInited) return (BindingsPackage)EPackage.Registry.INSTANCE.getEPackage(BindingsPackage.eNS_URI);

		// Obtain or create and register package
		BindingsPackageImpl theBindingsPackage = (BindingsPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof BindingsPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new BindingsPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		EcosystemmodelPackageImpl theEcosystemmodelPackage = (EcosystemmodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EcosystemmodelPackage.eNS_URI) instanceof EcosystemmodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EcosystemmodelPackage.eNS_URI) : EcosystemmodelPackage.eINSTANCE);
		LifecyclePackageImpl theLifecyclePackage = (LifecyclePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(LifecyclePackage.eNS_URI) instanceof LifecyclePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(LifecyclePackage.eNS_URI) : LifecyclePackage.eINSTANCE);
		ChoreographiesPackageImpl theChoreographiesPackage = (ChoreographiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ChoreographiesPackage.eNS_URI) instanceof ChoreographiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ChoreographiesPackage.eNS_URI) : ChoreographiesPackage.eINSTANCE);
		FoundationsPackageImpl theFoundationsPackage = (FoundationsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FoundationsPackage.eNS_URI) instanceof FoundationsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FoundationsPackage.eNS_URI) : FoundationsPackage.eINSTANCE);
		RelationshipsPackageImpl theRelationshipsPackage = (RelationshipsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RelationshipsPackage.eNS_URI) instanceof RelationshipsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RelationshipsPackage.eNS_URI) : RelationshipsPackage.eINSTANCE);
		SystemsPackageImpl theSystemsPackage = (SystemsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SystemsPackage.eNS_URI) instanceof SystemsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SystemsPackage.eNS_URI) : SystemsPackage.eINSTANCE);
		ModeltransformationsPackageImpl theModeltransformationsPackage = (ModeltransformationsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModeltransformationsPackage.eNS_URI) instanceof ModeltransformationsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModeltransformationsPackage.eNS_URI) : ModeltransformationsPackage.eINSTANCE);
		BehaviourPackageImpl theBehaviourPackage = (BehaviourPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BehaviourPackage.eNS_URI) instanceof BehaviourPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BehaviourPackage.eNS_URI) : BehaviourPackage.eINSTANCE);
		ModelsPackageImpl theModelsPackage = (ModelsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModelsPackage.eNS_URI) instanceof ModelsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModelsPackage.eNS_URI) : ModelsPackage.eINSTANCE);
		EcosystemintensionmodelPackageImpl theEcosystemintensionmodelPackage = (EcosystemintensionmodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EcosystemintensionmodelPackage.eNS_URI) instanceof EcosystemintensionmodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EcosystemintensionmodelPackage.eNS_URI) : EcosystemintensionmodelPackage.eINSTANCE);
		FeaturesPackageImpl theFeaturesPackage = (FeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FeaturesPackage.eNS_URI) instanceof FeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FeaturesPackage.eNS_URI) : FeaturesPackage.eINSTANCE);
		ContractualfeaturesPackageImpl theContractualfeaturesPackage = (ContractualfeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ContractualfeaturesPackage.eNS_URI) instanceof ContractualfeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ContractualfeaturesPackage.eNS_URI) : ContractualfeaturesPackage.eINSTANCE);
		FunctionalfeaturesPackageImpl theFunctionalfeaturesPackage = (FunctionalfeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FunctionalfeaturesPackage.eNS_URI) instanceof FunctionalfeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FunctionalfeaturesPackage.eNS_URI) : FunctionalfeaturesPackage.eINSTANCE);
		CooperativefeaturesPackageImpl theCooperativefeaturesPackage = (CooperativefeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CooperativefeaturesPackage.eNS_URI) instanceof CooperativefeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CooperativefeaturesPackage.eNS_URI) : CooperativefeaturesPackage.eINSTANCE);
		FacilityfeaturesPackageImpl theFacilityfeaturesPackage = (FacilityfeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FacilityfeaturesPackage.eNS_URI) instanceof FacilityfeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FacilityfeaturesPackage.eNS_URI) : FacilityfeaturesPackage.eINSTANCE);
		ExtrafunctionalfeaturesPackageImpl theExtrafunctionalfeaturesPackage = (ExtrafunctionalfeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExtrafunctionalfeaturesPackage.eNS_URI) instanceof ExtrafunctionalfeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExtrafunctionalfeaturesPackage.eNS_URI) : ExtrafunctionalfeaturesPackage.eINSTANCE);
		IntensionsPackageImpl theIntensionsPackage = (IntensionsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(IntensionsPackage.eNS_URI) instanceof IntensionsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(IntensionsPackage.eNS_URI) : IntensionsPackage.eINSTANCE);
		PropertiesPackageImpl thePropertiesPackage = (PropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PropertiesPackage.eNS_URI) instanceof PropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PropertiesPackage.eNS_URI) : PropertiesPackage.eINSTANCE);
		ContractualpropertiesPackageImpl theContractualpropertiesPackage = (ContractualpropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ContractualpropertiesPackage.eNS_URI) instanceof ContractualpropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ContractualpropertiesPackage.eNS_URI) : ContractualpropertiesPackage.eINSTANCE);
		CooperativepropertiesPackageImpl theCooperativepropertiesPackage = (CooperativepropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CooperativepropertiesPackage.eNS_URI) instanceof CooperativepropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CooperativepropertiesPackage.eNS_URI) : CooperativepropertiesPackage.eINSTANCE);
		FacilitypropertiesPackageImpl theFacilitypropertiesPackage = (FacilitypropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FacilitypropertiesPackage.eNS_URI) instanceof FacilitypropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FacilitypropertiesPackage.eNS_URI) : FacilitypropertiesPackage.eINSTANCE);
		FunctionalpropertiesPackageImpl theFunctionalpropertiesPackage = (FunctionalpropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FunctionalpropertiesPackage.eNS_URI) instanceof FunctionalpropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FunctionalpropertiesPackage.eNS_URI) : FunctionalpropertiesPackage.eINSTANCE);
		DomainontologyPackageImpl theDomainontologyPackage = (DomainontologyPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DomainontologyPackage.eNS_URI) instanceof DomainontologyPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DomainontologyPackage.eNS_URI) : DomainontologyPackage.eINSTANCE);
		ContractingPackageImpl theContractingPackage = (ContractingPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ContractingPackage.eNS_URI) instanceof ContractingPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ContractingPackage.eNS_URI) : ContractingPackage.eINSTANCE);
		EntitiesPackageImpl theEntitiesPackage = (EntitiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EntitiesPackage.eNS_URI) instanceof EntitiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EntitiesPackage.eNS_URI) : EntitiesPackage.eINSTANCE);
		EntitykindsPackageImpl theEntitykindsPackage = (EntitykindsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EntitykindsPackage.eNS_URI) instanceof EntitykindsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EntitykindsPackage.eNS_URI) : EntitykindsPackage.eINSTANCE);
		ChannelsPackageImpl theChannelsPackage = (ChannelsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ChannelsPackage.eNS_URI) instanceof ChannelsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ChannelsPackage.eNS_URI) : ChannelsPackage.eINSTANCE);
		FacilitiesPackageImpl theFacilitiesPackage = (FacilitiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FacilitiesPackage.eNS_URI) instanceof FacilitiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FacilitiesPackage.eNS_URI) : FacilitiesPackage.eINSTANCE);
		ConceptsPackageImpl theConceptsPackage = (ConceptsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ConceptsPackage.eNS_URI) instanceof ConceptsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ConceptsPackage.eNS_URI) : ConceptsPackage.eINSTANCE);
		KnowledgemanagementmodelPackageImpl theKnowledgemanagementmodelPackage = (KnowledgemanagementmodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(KnowledgemanagementmodelPackage.eNS_URI) instanceof KnowledgemanagementmodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(KnowledgemanagementmodelPackage.eNS_URI) : KnowledgemanagementmodelPackage.eINSTANCE);
		RepositoriesPackageImpl theRepositoriesPackage = (RepositoriesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RepositoriesPackage.eNS_URI) instanceof RepositoriesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RepositoriesPackage.eNS_URI) : RepositoriesPackage.eINSTANCE);
		EngineeringmodelPackageImpl theEngineeringmodelPackage = (EngineeringmodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EngineeringmodelPackage.eNS_URI) instanceof EngineeringmodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EngineeringmodelPackage.eNS_URI) : EngineeringmodelPackage.eINSTANCE);
		EngineeringcapabilityPackageImpl theEngineeringcapabilityPackage = (EngineeringcapabilityPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EngineeringcapabilityPackage.eNS_URI) instanceof EngineeringcapabilityPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EngineeringcapabilityPackage.eNS_URI) : EngineeringcapabilityPackage.eINSTANCE);
		EngineeringspacePackageImpl theEngineeringspacePackage = (EngineeringspacePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EngineeringspacePackage.eNS_URI) instanceof EngineeringspacePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EngineeringspacePackage.eNS_URI) : EngineeringspacePackage.eINSTANCE);
		SeadescriptionPackageImpl theSeadescriptionPackage = (SeadescriptionPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SeadescriptionPackage.eNS_URI) instanceof SeadescriptionPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SeadescriptionPackage.eNS_URI) : SeadescriptionPackage.eINSTANCE);

		// Create package meta-data objects
		theBindingsPackage.createPackageContents();
		theEcosystemmodelPackage.createPackageContents();
		theLifecyclePackage.createPackageContents();
		theChoreographiesPackage.createPackageContents();
		theFoundationsPackage.createPackageContents();
		theRelationshipsPackage.createPackageContents();
		theSystemsPackage.createPackageContents();
		theModeltransformationsPackage.createPackageContents();
		theBehaviourPackage.createPackageContents();
		theModelsPackage.createPackageContents();
		theEcosystemintensionmodelPackage.createPackageContents();
		theFeaturesPackage.createPackageContents();
		theContractualfeaturesPackage.createPackageContents();
		theFunctionalfeaturesPackage.createPackageContents();
		theCooperativefeaturesPackage.createPackageContents();
		theFacilityfeaturesPackage.createPackageContents();
		theExtrafunctionalfeaturesPackage.createPackageContents();
		theIntensionsPackage.createPackageContents();
		thePropertiesPackage.createPackageContents();
		theContractualpropertiesPackage.createPackageContents();
		theCooperativepropertiesPackage.createPackageContents();
		theFacilitypropertiesPackage.createPackageContents();
		theFunctionalpropertiesPackage.createPackageContents();
		theDomainontologyPackage.createPackageContents();
		theContractingPackage.createPackageContents();
		theEntitiesPackage.createPackageContents();
		theEntitykindsPackage.createPackageContents();
		theChannelsPackage.createPackageContents();
		theFacilitiesPackage.createPackageContents();
		theConceptsPackage.createPackageContents();
		theKnowledgemanagementmodelPackage.createPackageContents();
		theRepositoriesPackage.createPackageContents();
		theEngineeringmodelPackage.createPackageContents();
		theEngineeringcapabilityPackage.createPackageContents();
		theEngineeringspacePackage.createPackageContents();
		theSeadescriptionPackage.createPackageContents();

		// Initialize created meta-data
		theBindingsPackage.initializePackageContents();
		theEcosystemmodelPackage.initializePackageContents();
		theLifecyclePackage.initializePackageContents();
		theChoreographiesPackage.initializePackageContents();
		theFoundationsPackage.initializePackageContents();
		theRelationshipsPackage.initializePackageContents();
		theSystemsPackage.initializePackageContents();
		theModeltransformationsPackage.initializePackageContents();
		theBehaviourPackage.initializePackageContents();
		theModelsPackage.initializePackageContents();
		theEcosystemintensionmodelPackage.initializePackageContents();
		theFeaturesPackage.initializePackageContents();
		theContractualfeaturesPackage.initializePackageContents();
		theFunctionalfeaturesPackage.initializePackageContents();
		theCooperativefeaturesPackage.initializePackageContents();
		theFacilityfeaturesPackage.initializePackageContents();
		theExtrafunctionalfeaturesPackage.initializePackageContents();
		theIntensionsPackage.initializePackageContents();
		thePropertiesPackage.initializePackageContents();
		theContractualpropertiesPackage.initializePackageContents();
		theCooperativepropertiesPackage.initializePackageContents();
		theFacilitypropertiesPackage.initializePackageContents();
		theFunctionalpropertiesPackage.initializePackageContents();
		theDomainontologyPackage.initializePackageContents();
		theContractingPackage.initializePackageContents();
		theEntitiesPackage.initializePackageContents();
		theEntitykindsPackage.initializePackageContents();
		theChannelsPackage.initializePackageContents();
		theFacilitiesPackage.initializePackageContents();
		theConceptsPackage.initializePackageContents();
		theKnowledgemanagementmodelPackage.initializePackageContents();
		theRepositoriesPackage.initializePackageContents();
		theEngineeringmodelPackage.initializePackageContents();
		theEngineeringcapabilityPackage.initializePackageContents();
		theEngineeringspacePackage.initializePackageContents();
		theSeadescriptionPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theBindingsPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(BindingsPackage.eNS_URI, theBindingsPackage);
		return theBindingsPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyBinding() {
		return propertyBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyBinding_Target() {
		return (EReference)propertyBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyBinding_Bindableproperty() {
		return (EReference)propertyBindingEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBindingSpecification() {
		return bindingSpecificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyBindingTarget() {
		return propertyBindingTargetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBindingTarget() {
		return bindingTargetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBindableProperty() {
		return bindablePropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBindableElement() {
		return bindableElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFeatureBinding() {
		return featureBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFeatureBinding_Target() {
		return (EReference)featureBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFeatureBinding_Bindablefeature() {
		return (EReference)featureBindingEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFeatureBindingTarget() {
		return featureBindingTargetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPortBinding() {
		return portBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPortBinding_Operation() {
		return (EReference)portBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPortBinding_Bindingport() {
		return (EReference)portBindingEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExtraFunctionalFeatureTarget() {
		return extraFunctionalFeatureTargetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCooperativeFeatureTarget() {
		return cooperativeFeatureTargetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContractualFeatureTarget() {
		return contractualFeatureTargetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCooperativePropertyTarget() {
		return cooperativePropertyTargetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCooperativeFeatureBinding() {
		return cooperativeFeatureBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCooperativeFeatureBinding_Cooperativefeature() {
		return (EReference)cooperativeFeatureBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExtraFunctionalFeatureBinding() {
		return extraFunctionalFeatureBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getExtraFunctionalFeatureBinding_Extrafunctionalfeature() {
		return (EReference)extraFunctionalFeatureBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContractualFeatureBinding() {
		return contractualFeatureBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getContractualFeatureBinding_Contractualfeature() {
		return (EReference)contractualFeatureBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContractualPropertyTarget() {
		return contractualPropertyTargetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCooperativePropertyBinding() {
		return cooperativePropertyBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCooperativePropertyBinding_Cooperativeproperty() {
		return (EReference)cooperativePropertyBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContractualPropertyBinding() {
		return contractualPropertyBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getContractualPropertyBinding_Contractualproperty() {
		return (EReference)contractualPropertyBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBindableFeature() {
		return bindableFeatureEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BindingsFactory getBindingsFactory() {
		return (BindingsFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		propertyBindingEClass = createEClass(PROPERTY_BINDING);
		createEReference(propertyBindingEClass, PROPERTY_BINDING__TARGET);
		createEReference(propertyBindingEClass, PROPERTY_BINDING__BINDABLEPROPERTY);

		bindingSpecificationEClass = createEClass(BINDING_SPECIFICATION);

		propertyBindingTargetEClass = createEClass(PROPERTY_BINDING_TARGET);

		bindingTargetEClass = createEClass(BINDING_TARGET);

		bindablePropertyEClass = createEClass(BINDABLE_PROPERTY);

		bindableElementEClass = createEClass(BINDABLE_ELEMENT);

		featureBindingEClass = createEClass(FEATURE_BINDING);
		createEReference(featureBindingEClass, FEATURE_BINDING__TARGET);
		createEReference(featureBindingEClass, FEATURE_BINDING__BINDABLEFEATURE);

		featureBindingTargetEClass = createEClass(FEATURE_BINDING_TARGET);

		portBindingEClass = createEClass(PORT_BINDING);
		createEReference(portBindingEClass, PORT_BINDING__OPERATION);
		createEReference(portBindingEClass, PORT_BINDING__BINDINGPORT);

		extraFunctionalFeatureTargetEClass = createEClass(EXTRA_FUNCTIONAL_FEATURE_TARGET);

		cooperativeFeatureTargetEClass = createEClass(COOPERATIVE_FEATURE_TARGET);

		contractualFeatureTargetEClass = createEClass(CONTRACTUAL_FEATURE_TARGET);

		cooperativePropertyTargetEClass = createEClass(COOPERATIVE_PROPERTY_TARGET);

		cooperativeFeatureBindingEClass = createEClass(COOPERATIVE_FEATURE_BINDING);
		createEReference(cooperativeFeatureBindingEClass, COOPERATIVE_FEATURE_BINDING__COOPERATIVEFEATURE);

		extraFunctionalFeatureBindingEClass = createEClass(EXTRA_FUNCTIONAL_FEATURE_BINDING);
		createEReference(extraFunctionalFeatureBindingEClass, EXTRA_FUNCTIONAL_FEATURE_BINDING__EXTRAFUNCTIONALFEATURE);

		contractualFeatureBindingEClass = createEClass(CONTRACTUAL_FEATURE_BINDING);
		createEReference(contractualFeatureBindingEClass, CONTRACTUAL_FEATURE_BINDING__CONTRACTUALFEATURE);

		contractualPropertyTargetEClass = createEClass(CONTRACTUAL_PROPERTY_TARGET);

		cooperativePropertyBindingEClass = createEClass(COOPERATIVE_PROPERTY_BINDING);
		createEReference(cooperativePropertyBindingEClass, COOPERATIVE_PROPERTY_BINDING__COOPERATIVEPROPERTY);

		contractualPropertyBindingEClass = createEClass(CONTRACTUAL_PROPERTY_BINDING);
		createEReference(contractualPropertyBindingEClass, CONTRACTUAL_PROPERTY_BINDING__CONTRACTUALPROPERTY);

		bindableFeatureEClass = createEClass(BINDABLE_FEATURE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		EcosystemintensionmodelPackage theEcosystemintensionmodelPackage = (EcosystemintensionmodelPackage)EPackage.Registry.INSTANCE.getEPackage(EcosystemintensionmodelPackage.eNS_URI);
		EngineeringspacePackage theEngineeringspacePackage = (EngineeringspacePackage)EPackage.Registry.INSTANCE.getEPackage(EngineeringspacePackage.eNS_URI);
		EcosystemmodelPackage theEcosystemmodelPackage = (EcosystemmodelPackage)EPackage.Registry.INSTANCE.getEPackage(EcosystemmodelPackage.eNS_URI);
		FacilitypropertiesPackage theFacilitypropertiesPackage = (FacilitypropertiesPackage)EPackage.Registry.INSTANCE.getEPackage(FacilitypropertiesPackage.eNS_URI);
		CooperativefeaturesPackage theCooperativefeaturesPackage = (CooperativefeaturesPackage)EPackage.Registry.INSTANCE.getEPackage(CooperativefeaturesPackage.eNS_URI);
		ExtrafunctionalfeaturesPackage theExtrafunctionalfeaturesPackage = (ExtrafunctionalfeaturesPackage)EPackage.Registry.INSTANCE.getEPackage(ExtrafunctionalfeaturesPackage.eNS_URI);
		ContractualfeaturesPackage theContractualfeaturesPackage = (ContractualfeaturesPackage)EPackage.Registry.INSTANCE.getEPackage(ContractualfeaturesPackage.eNS_URI);
		CooperativepropertiesPackage theCooperativepropertiesPackage = (CooperativepropertiesPackage)EPackage.Registry.INSTANCE.getEPackage(CooperativepropertiesPackage.eNS_URI);
		ContractualpropertiesPackage theContractualpropertiesPackage = (ContractualpropertiesPackage)EPackage.Registry.INSTANCE.getEPackage(ContractualpropertiesPackage.eNS_URI);

		// Add supertypes to classes
		propertyBindingEClass.getESuperTypes().add(theEcosystemintensionmodelPackage.getInstantiatableElement());
		propertyBindingEClass.getESuperTypes().add(this.getBindingSpecification());
		bindingSpecificationEClass.getESuperTypes().add(theEngineeringspacePackage.getEngineeringElement());
		propertyBindingTargetEClass.getESuperTypes().add(this.getBindingTarget());
		bindablePropertyEClass.getESuperTypes().add(this.getBindableElement());
		bindableElementEClass.getESuperTypes().add(theEngineeringspacePackage.getEngineeringElement());
		featureBindingEClass.getESuperTypes().add(theEcosystemintensionmodelPackage.getInstantiatableElement());
		featureBindingEClass.getESuperTypes().add(this.getBindingSpecification());
		featureBindingTargetEClass.getESuperTypes().add(this.getBindingTarget());
		portBindingEClass.getESuperTypes().add(this.getPropertyBinding());
		extraFunctionalFeatureTargetEClass.getESuperTypes().add(this.getFeatureBindingTarget());
		cooperativeFeatureTargetEClass.getESuperTypes().add(this.getFeatureBindingTarget());
		contractualFeatureTargetEClass.getESuperTypes().add(this.getFeatureBindingTarget());
		cooperativePropertyTargetEClass.getESuperTypes().add(this.getPropertyBindingTarget());
		cooperativeFeatureBindingEClass.getESuperTypes().add(this.getFeatureBinding());
		extraFunctionalFeatureBindingEClass.getESuperTypes().add(this.getFeatureBinding());
		contractualFeatureBindingEClass.getESuperTypes().add(this.getFeatureBinding());
		contractualPropertyTargetEClass.getESuperTypes().add(this.getPropertyBindingTarget());
		cooperativePropertyBindingEClass.getESuperTypes().add(this.getPropertyBinding());
		contractualPropertyBindingEClass.getESuperTypes().add(this.getPropertyBinding());
		bindableFeatureEClass.getESuperTypes().add(this.getBindableElement());

		// Initialize classes and features; add operations and parameters
		initEClass(propertyBindingEClass, PropertyBinding.class, "PropertyBinding", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPropertyBinding_Target(), this.getPropertyBindingTarget(), null, "target", null, 1, 1, PropertyBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getPropertyBinding_Bindableproperty(), this.getBindableProperty(), null, "bindableproperty", null, 1, -1, PropertyBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(bindingSpecificationEClass, BindingSpecification.class, "BindingSpecification", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(propertyBindingTargetEClass, PropertyBindingTarget.class, "PropertyBindingTarget", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(bindingTargetEClass, BindingTarget.class, "BindingTarget", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(bindablePropertyEClass, BindableProperty.class, "BindableProperty", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(bindableElementEClass, BindableElement.class, "BindableElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(featureBindingEClass, FeatureBinding.class, "FeatureBinding", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFeatureBinding_Target(), this.getFeatureBindingTarget(), null, "target", null, 1, 1, FeatureBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getFeatureBinding_Bindablefeature(), this.getBindableFeature(), null, "bindablefeature", null, 1, -1, FeatureBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(featureBindingTargetEClass, FeatureBindingTarget.class, "FeatureBindingTarget", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(portBindingEClass, PortBinding.class, "PortBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPortBinding_Operation(), theEcosystemmodelPackage.getServiceOperation(), null, "operation", null, 1, 1, PortBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getPortBinding_Bindingport(), theFacilitypropertiesPackage.getBindingPort(), null, "bindingport", null, 1, 1, PortBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(extraFunctionalFeatureTargetEClass, ExtraFunctionalFeatureTarget.class, "ExtraFunctionalFeatureTarget", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cooperativeFeatureTargetEClass, CooperativeFeatureTarget.class, "CooperativeFeatureTarget", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(contractualFeatureTargetEClass, ContractualFeatureTarget.class, "ContractualFeatureTarget", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cooperativePropertyTargetEClass, CooperativePropertyTarget.class, "CooperativePropertyTarget", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cooperativeFeatureBindingEClass, CooperativeFeatureBinding.class, "CooperativeFeatureBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCooperativeFeatureBinding_Cooperativefeature(), theCooperativefeaturesPackage.getCooperativeFeature(), null, "cooperativefeature", null, 1, -1, CooperativeFeatureBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(extraFunctionalFeatureBindingEClass, ExtraFunctionalFeatureBinding.class, "ExtraFunctionalFeatureBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExtraFunctionalFeatureBinding_Extrafunctionalfeature(), theExtrafunctionalfeaturesPackage.getExtraFunctionalFeature(), null, "extrafunctionalfeature", null, 1, -1, ExtraFunctionalFeatureBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(contractualFeatureBindingEClass, ContractualFeatureBinding.class, "ContractualFeatureBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getContractualFeatureBinding_Contractualfeature(), theContractualfeaturesPackage.getContractualFeature(), null, "contractualfeature", null, 1, -1, ContractualFeatureBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(contractualPropertyTargetEClass, ContractualPropertyTarget.class, "ContractualPropertyTarget", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cooperativePropertyBindingEClass, CooperativePropertyBinding.class, "CooperativePropertyBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCooperativePropertyBinding_Cooperativeproperty(), theCooperativepropertiesPackage.getCooperativeProperty(), null, "cooperativeproperty", null, 1, -1, CooperativePropertyBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(contractualPropertyBindingEClass, ContractualPropertyBinding.class, "ContractualPropertyBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getContractualPropertyBinding_Contractualproperty(), theContractualpropertiesPackage.getContractualProperty(), null, "contractualproperty", null, 1, -1, ContractualPropertyBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(bindableFeatureEClass, BindableFeature.class, "BindableFeature", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
	}

} //BindingsPackageImpl
