/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.impl;

import org.cinco.metamodel.ecosystem.domainontology.DomainontologyPackage;

import org.cinco.metamodel.ecosystem.domainontology.channels.ChannelsPackage;

import org.cinco.metamodel.ecosystem.domainontology.channels.impl.ChannelsPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.concepts.ConceptsPackage;

import org.cinco.metamodel.ecosystem.domainontology.concepts.impl.ConceptsPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.contracting.ContractingPackage;

import org.cinco.metamodel.ecosystem.domainontology.contracting.impl.ContractingPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.entities.EntitiesPackage;

import org.cinco.metamodel.ecosystem.domainontology.entities.impl.EntitiesPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.entitykinds.EntitykindsPackage;

import org.cinco.metamodel.ecosystem.domainontology.entitykinds.impl.EntitykindsPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.facilities.FacilitiesPackage;

import org.cinco.metamodel.ecosystem.domainontology.facilities.impl.FacilitiesPackageImpl;

import org.cinco.metamodel.ecosystem.domainontology.impl.DomainontologyPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.EcosystemintensionmodelPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.BindingsPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.bindings.impl.BindingsPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.FeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.contractualfeatures.ContractualfeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.contractualfeatures.impl.ContractualfeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.cooperativefeatures.CooperativefeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.cooperativefeatures.impl.CooperativefeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.extrafunctionalfeatures.ExtrafunctionalfeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.extrafunctionalfeatures.impl.ExtrafunctionalfeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.facilityfeatures.FacilityfeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.facilityfeatures.impl.FacilityfeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.functionalfeatures.FunctionalfeaturesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.functionalfeatures.impl.FunctionalfeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.impl.FeaturesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.impl.EcosystemintensionmodelPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.BindingTypeIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.BusinessDocumentIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.BusinessDocumentKindIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.BusinessServiceIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.BusinessServiceKindIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ChannelTypeIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ComponentServiceIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ComponentServiceKindIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ConceptIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.CooperationFacilityIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.DomainConceptIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.EndpointBinding;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.EndpointEntityIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.EndpointKindIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.EntityIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.EntityKindIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.InformationEntityIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.InformationEntityKindIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.IntensionsFactory;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.IntensionsPackage;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.LegalEntityIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.LegalEntityKindIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.MessageExchange;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ServiceChannelIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ServiceContractIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ServiceEndpointIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ServiceEndpointKindIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ServiceIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ServiceInterface;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ServiceKindIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ServiceLiaisonIntension;
import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.ServiceOfferIntension;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.PropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.contractualproperties.ContractualpropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.contractualproperties.impl.ContractualpropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.cooperativeproperties.CooperativepropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.cooperativeproperties.impl.CooperativepropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.facilityproperties.FacilitypropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.facilityproperties.impl.FacilitypropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.functionalproperties.FunctionalpropertiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.functionalproperties.impl.FunctionalpropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.properties.impl.PropertiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemmodel.EcosystemmodelPackage;

import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.ChoreographiesPackage;

import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.ChoreographiesPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemmodel.impl.EcosystemmodelPackageImpl;

import org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.LifecyclePackage;

import org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.impl.LifecyclePackageImpl;

import org.cinco.metamodel.ecosystem.engineeringmodel.EngineeringmodelPackage;

import org.cinco.metamodel.ecosystem.engineeringmodel.engineeringcapability.EngineeringcapabilityPackage;

import org.cinco.metamodel.ecosystem.engineeringmodel.engineeringcapability.impl.EngineeringcapabilityPackageImpl;

import org.cinco.metamodel.ecosystem.engineeringmodel.engineeringspace.EngineeringspacePackage;

import org.cinco.metamodel.ecosystem.engineeringmodel.engineeringspace.impl.EngineeringspacePackageImpl;

import org.cinco.metamodel.ecosystem.engineeringmodel.impl.EngineeringmodelPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.FoundationsPackage;

import org.cinco.metamodel.ecosystem.foundations.behaviour.BehaviourPackage;

import org.cinco.metamodel.ecosystem.foundations.behaviour.impl.BehaviourPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.impl.FoundationsPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.models.ModelsPackage;

import org.cinco.metamodel.ecosystem.foundations.models.impl.ModelsPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.modeltransformations.ModeltransformationsPackage;

import org.cinco.metamodel.ecosystem.foundations.modeltransformations.impl.ModeltransformationsPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.relationships.RelationshipsPackage;

import org.cinco.metamodel.ecosystem.foundations.relationships.impl.RelationshipsPackageImpl;

import org.cinco.metamodel.ecosystem.foundations.systems.SystemsPackage;

import org.cinco.metamodel.ecosystem.foundations.systems.impl.SystemsPackageImpl;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.KnowledgemanagementmodelPackage;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.impl.KnowledgemanagementmodelPackageImpl;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.RepositoriesPackage;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl.RepositoriesPackageImpl;

import org.cinco.metamodel.ecosystem.seadescription.SeadescriptionPackage;

import org.cinco.metamodel.ecosystem.seadescription.impl.SeadescriptionPackageImpl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class IntensionsPackageImpl extends EPackageImpl implements IntensionsPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass informationEntityKindIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass entityKindIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass conceptIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass businessDocumentKindIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceEndpointKindIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass endpointKindIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass legalEntityKindIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass informationEntityIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass entityIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass legalEntityIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass businessDocumentIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass endpointEntityIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass componentServiceIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass messageExchangeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceEndpointIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass componentServiceKindIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceOfferIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceContractIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass businessServiceKindIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cooperationFacilityIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bindingTypeIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass businessServiceIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass channelTypeIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceLiaisonIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass endpointBindingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceInterfaceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass domainConceptIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceChannelIntensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceKindIntensionEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.cinco.metamodel.ecosystem.ecosystemintensionmodel.intensions.IntensionsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private IntensionsPackageImpl() {
		super(eNS_URI, IntensionsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link IntensionsPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static IntensionsPackage init() {
		if (isInited) return (IntensionsPackage)EPackage.Registry.INSTANCE.getEPackage(IntensionsPackage.eNS_URI);

		// Obtain or create and register package
		IntensionsPackageImpl theIntensionsPackage = (IntensionsPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof IntensionsPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new IntensionsPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		EcosystemmodelPackageImpl theEcosystemmodelPackage = (EcosystemmodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EcosystemmodelPackage.eNS_URI) instanceof EcosystemmodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EcosystemmodelPackage.eNS_URI) : EcosystemmodelPackage.eINSTANCE);
		LifecyclePackageImpl theLifecyclePackage = (LifecyclePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(LifecyclePackage.eNS_URI) instanceof LifecyclePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(LifecyclePackage.eNS_URI) : LifecyclePackage.eINSTANCE);
		ChoreographiesPackageImpl theChoreographiesPackage = (ChoreographiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ChoreographiesPackage.eNS_URI) instanceof ChoreographiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ChoreographiesPackage.eNS_URI) : ChoreographiesPackage.eINSTANCE);
		FoundationsPackageImpl theFoundationsPackage = (FoundationsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FoundationsPackage.eNS_URI) instanceof FoundationsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FoundationsPackage.eNS_URI) : FoundationsPackage.eINSTANCE);
		RelationshipsPackageImpl theRelationshipsPackage = (RelationshipsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RelationshipsPackage.eNS_URI) instanceof RelationshipsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RelationshipsPackage.eNS_URI) : RelationshipsPackage.eINSTANCE);
		SystemsPackageImpl theSystemsPackage = (SystemsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SystemsPackage.eNS_URI) instanceof SystemsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SystemsPackage.eNS_URI) : SystemsPackage.eINSTANCE);
		ModeltransformationsPackageImpl theModeltransformationsPackage = (ModeltransformationsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModeltransformationsPackage.eNS_URI) instanceof ModeltransformationsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModeltransformationsPackage.eNS_URI) : ModeltransformationsPackage.eINSTANCE);
		BehaviourPackageImpl theBehaviourPackage = (BehaviourPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BehaviourPackage.eNS_URI) instanceof BehaviourPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BehaviourPackage.eNS_URI) : BehaviourPackage.eINSTANCE);
		ModelsPackageImpl theModelsPackage = (ModelsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModelsPackage.eNS_URI) instanceof ModelsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModelsPackage.eNS_URI) : ModelsPackage.eINSTANCE);
		EcosystemintensionmodelPackageImpl theEcosystemintensionmodelPackage = (EcosystemintensionmodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EcosystemintensionmodelPackage.eNS_URI) instanceof EcosystemintensionmodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EcosystemintensionmodelPackage.eNS_URI) : EcosystemintensionmodelPackage.eINSTANCE);
		FeaturesPackageImpl theFeaturesPackage = (FeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FeaturesPackage.eNS_URI) instanceof FeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FeaturesPackage.eNS_URI) : FeaturesPackage.eINSTANCE);
		ContractualfeaturesPackageImpl theContractualfeaturesPackage = (ContractualfeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ContractualfeaturesPackage.eNS_URI) instanceof ContractualfeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ContractualfeaturesPackage.eNS_URI) : ContractualfeaturesPackage.eINSTANCE);
		FunctionalfeaturesPackageImpl theFunctionalfeaturesPackage = (FunctionalfeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FunctionalfeaturesPackage.eNS_URI) instanceof FunctionalfeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FunctionalfeaturesPackage.eNS_URI) : FunctionalfeaturesPackage.eINSTANCE);
		CooperativefeaturesPackageImpl theCooperativefeaturesPackage = (CooperativefeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CooperativefeaturesPackage.eNS_URI) instanceof CooperativefeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CooperativefeaturesPackage.eNS_URI) : CooperativefeaturesPackage.eINSTANCE);
		FacilityfeaturesPackageImpl theFacilityfeaturesPackage = (FacilityfeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FacilityfeaturesPackage.eNS_URI) instanceof FacilityfeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FacilityfeaturesPackage.eNS_URI) : FacilityfeaturesPackage.eINSTANCE);
		ExtrafunctionalfeaturesPackageImpl theExtrafunctionalfeaturesPackage = (ExtrafunctionalfeaturesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExtrafunctionalfeaturesPackage.eNS_URI) instanceof ExtrafunctionalfeaturesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExtrafunctionalfeaturesPackage.eNS_URI) : ExtrafunctionalfeaturesPackage.eINSTANCE);
		BindingsPackageImpl theBindingsPackage = (BindingsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BindingsPackage.eNS_URI) instanceof BindingsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BindingsPackage.eNS_URI) : BindingsPackage.eINSTANCE);
		PropertiesPackageImpl thePropertiesPackage = (PropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PropertiesPackage.eNS_URI) instanceof PropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PropertiesPackage.eNS_URI) : PropertiesPackage.eINSTANCE);
		ContractualpropertiesPackageImpl theContractualpropertiesPackage = (ContractualpropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ContractualpropertiesPackage.eNS_URI) instanceof ContractualpropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ContractualpropertiesPackage.eNS_URI) : ContractualpropertiesPackage.eINSTANCE);
		CooperativepropertiesPackageImpl theCooperativepropertiesPackage = (CooperativepropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CooperativepropertiesPackage.eNS_URI) instanceof CooperativepropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CooperativepropertiesPackage.eNS_URI) : CooperativepropertiesPackage.eINSTANCE);
		FacilitypropertiesPackageImpl theFacilitypropertiesPackage = (FacilitypropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FacilitypropertiesPackage.eNS_URI) instanceof FacilitypropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FacilitypropertiesPackage.eNS_URI) : FacilitypropertiesPackage.eINSTANCE);
		FunctionalpropertiesPackageImpl theFunctionalpropertiesPackage = (FunctionalpropertiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FunctionalpropertiesPackage.eNS_URI) instanceof FunctionalpropertiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FunctionalpropertiesPackage.eNS_URI) : FunctionalpropertiesPackage.eINSTANCE);
		DomainontologyPackageImpl theDomainontologyPackage = (DomainontologyPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DomainontologyPackage.eNS_URI) instanceof DomainontologyPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DomainontologyPackage.eNS_URI) : DomainontologyPackage.eINSTANCE);
		ContractingPackageImpl theContractingPackage = (ContractingPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ContractingPackage.eNS_URI) instanceof ContractingPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ContractingPackage.eNS_URI) : ContractingPackage.eINSTANCE);
		EntitiesPackageImpl theEntitiesPackage = (EntitiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EntitiesPackage.eNS_URI) instanceof EntitiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EntitiesPackage.eNS_URI) : EntitiesPackage.eINSTANCE);
		EntitykindsPackageImpl theEntitykindsPackage = (EntitykindsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EntitykindsPackage.eNS_URI) instanceof EntitykindsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EntitykindsPackage.eNS_URI) : EntitykindsPackage.eINSTANCE);
		ChannelsPackageImpl theChannelsPackage = (ChannelsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ChannelsPackage.eNS_URI) instanceof ChannelsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ChannelsPackage.eNS_URI) : ChannelsPackage.eINSTANCE);
		FacilitiesPackageImpl theFacilitiesPackage = (FacilitiesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FacilitiesPackage.eNS_URI) instanceof FacilitiesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FacilitiesPackage.eNS_URI) : FacilitiesPackage.eINSTANCE);
		ConceptsPackageImpl theConceptsPackage = (ConceptsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ConceptsPackage.eNS_URI) instanceof ConceptsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ConceptsPackage.eNS_URI) : ConceptsPackage.eINSTANCE);
		KnowledgemanagementmodelPackageImpl theKnowledgemanagementmodelPackage = (KnowledgemanagementmodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(KnowledgemanagementmodelPackage.eNS_URI) instanceof KnowledgemanagementmodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(KnowledgemanagementmodelPackage.eNS_URI) : KnowledgemanagementmodelPackage.eINSTANCE);
		RepositoriesPackageImpl theRepositoriesPackage = (RepositoriesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RepositoriesPackage.eNS_URI) instanceof RepositoriesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RepositoriesPackage.eNS_URI) : RepositoriesPackage.eINSTANCE);
		EngineeringmodelPackageImpl theEngineeringmodelPackage = (EngineeringmodelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EngineeringmodelPackage.eNS_URI) instanceof EngineeringmodelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EngineeringmodelPackage.eNS_URI) : EngineeringmodelPackage.eINSTANCE);
		EngineeringcapabilityPackageImpl theEngineeringcapabilityPackage = (EngineeringcapabilityPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EngineeringcapabilityPackage.eNS_URI) instanceof EngineeringcapabilityPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EngineeringcapabilityPackage.eNS_URI) : EngineeringcapabilityPackage.eINSTANCE);
		EngineeringspacePackageImpl theEngineeringspacePackage = (EngineeringspacePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EngineeringspacePackage.eNS_URI) instanceof EngineeringspacePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EngineeringspacePackage.eNS_URI) : EngineeringspacePackage.eINSTANCE);
		SeadescriptionPackageImpl theSeadescriptionPackage = (SeadescriptionPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SeadescriptionPackage.eNS_URI) instanceof SeadescriptionPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SeadescriptionPackage.eNS_URI) : SeadescriptionPackage.eINSTANCE);

		// Create package meta-data objects
		theIntensionsPackage.createPackageContents();
		theEcosystemmodelPackage.createPackageContents();
		theLifecyclePackage.createPackageContents();
		theChoreographiesPackage.createPackageContents();
		theFoundationsPackage.createPackageContents();
		theRelationshipsPackage.createPackageContents();
		theSystemsPackage.createPackageContents();
		theModeltransformationsPackage.createPackageContents();
		theBehaviourPackage.createPackageContents();
		theModelsPackage.createPackageContents();
		theEcosystemintensionmodelPackage.createPackageContents();
		theFeaturesPackage.createPackageContents();
		theContractualfeaturesPackage.createPackageContents();
		theFunctionalfeaturesPackage.createPackageContents();
		theCooperativefeaturesPackage.createPackageContents();
		theFacilityfeaturesPackage.createPackageContents();
		theExtrafunctionalfeaturesPackage.createPackageContents();
		theBindingsPackage.createPackageContents();
		thePropertiesPackage.createPackageContents();
		theContractualpropertiesPackage.createPackageContents();
		theCooperativepropertiesPackage.createPackageContents();
		theFacilitypropertiesPackage.createPackageContents();
		theFunctionalpropertiesPackage.createPackageContents();
		theDomainontologyPackage.createPackageContents();
		theContractingPackage.createPackageContents();
		theEntitiesPackage.createPackageContents();
		theEntitykindsPackage.createPackageContents();
		theChannelsPackage.createPackageContents();
		theFacilitiesPackage.createPackageContents();
		theConceptsPackage.createPackageContents();
		theKnowledgemanagementmodelPackage.createPackageContents();
		theRepositoriesPackage.createPackageContents();
		theEngineeringmodelPackage.createPackageContents();
		theEngineeringcapabilityPackage.createPackageContents();
		theEngineeringspacePackage.createPackageContents();
		theSeadescriptionPackage.createPackageContents();

		// Initialize created meta-data
		theIntensionsPackage.initializePackageContents();
		theEcosystemmodelPackage.initializePackageContents();
		theLifecyclePackage.initializePackageContents();
		theChoreographiesPackage.initializePackageContents();
		theFoundationsPackage.initializePackageContents();
		theRelationshipsPackage.initializePackageContents();
		theSystemsPackage.initializePackageContents();
		theModeltransformationsPackage.initializePackageContents();
		theBehaviourPackage.initializePackageContents();
		theModelsPackage.initializePackageContents();
		theEcosystemintensionmodelPackage.initializePackageContents();
		theFeaturesPackage.initializePackageContents();
		theContractualfeaturesPackage.initializePackageContents();
		theFunctionalfeaturesPackage.initializePackageContents();
		theCooperativefeaturesPackage.initializePackageContents();
		theFacilityfeaturesPackage.initializePackageContents();
		theExtrafunctionalfeaturesPackage.initializePackageContents();
		theBindingsPackage.initializePackageContents();
		thePropertiesPackage.initializePackageContents();
		theContractualpropertiesPackage.initializePackageContents();
		theCooperativepropertiesPackage.initializePackageContents();
		theFacilitypropertiesPackage.initializePackageContents();
		theFunctionalpropertiesPackage.initializePackageContents();
		theDomainontologyPackage.initializePackageContents();
		theContractingPackage.initializePackageContents();
		theEntitiesPackage.initializePackageContents();
		theEntitykindsPackage.initializePackageContents();
		theChannelsPackage.initializePackageContents();
		theFacilitiesPackage.initializePackageContents();
		theConceptsPackage.initializePackageContents();
		theKnowledgemanagementmodelPackage.initializePackageContents();
		theRepositoriesPackage.initializePackageContents();
		theEngineeringmodelPackage.initializePackageContents();
		theEngineeringcapabilityPackage.initializePackageContents();
		theEngineeringspacePackage.initializePackageContents();
		theSeadescriptionPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theIntensionsPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(IntensionsPackage.eNS_URI, theIntensionsPackage);
		return theIntensionsPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInformationEntityKindIntension() {
		return informationEntityKindIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInformationEntityKindIntension_Informationfeature() {
		return (EReference)informationEntityKindIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEntityKindIntension() {
		return entityKindIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEntityKindIntension_Feature() {
		return (EReference)entityKindIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConceptIntension() {
		return conceptIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getConceptIntension_Elements() {
		return (EReference)conceptIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBusinessDocumentKindIntension() {
		return businessDocumentKindIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBusinessDocumentKindIntension_Documenttype() {
		return (EReference)businessDocumentKindIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceEndpointKindIntension() {
		return serviceEndpointKindIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEndpointKindIntension() {
		return endpointKindIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndpointKindIntension_Endpointfeature() {
		return (EReference)endpointKindIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndpointKindIntension_Addresskind() {
		return (EReference)endpointKindIntensionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLegalEntityKindIntension() {
		return legalEntityKindIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLegalEntityKindIntension_Cooperativefeature() {
		return (EReference)legalEntityKindIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInformationEntityIntension() {
		return informationEntityIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInformationEntityIntension_Informationproperty() {
		return (EReference)informationEntityIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEntityIntension() {
		return entityIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEntityIntension_Property() {
		return (EReference)entityIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLegalEntityIntension() {
		return legalEntityIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLegalEntityIntension_Cooperativeproperty() {
		return (EReference)legalEntityIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBusinessDocumentIntension() {
		return businessDocumentIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBusinessDocumentIntension_Element() {
		return (EReference)businessDocumentIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEndpointEntityIntension() {
		return endpointEntityIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndpointEntityIntension_Endpointproperty() {
		return (EReference)endpointEntityIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndpointEntityIntension_Address() {
		return (EReference)endpointEntityIntensionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceIntension() {
		return serviceIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceIntension_Serviceproperty() {
		return (EReference)serviceIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComponentServiceIntension() {
		return componentServiceIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getComponentServiceIntension_Componentserviceproperty() {
		return (EReference)componentServiceIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getComponentServiceIntension_Exchange() {
		return (EReference)componentServiceIntensionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMessageExchange() {
		return messageExchangeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMessageExchange_Operations() {
		return (EReference)messageExchangeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceEndpointIntension() {
		return serviceEndpointIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComponentServiceKindIntension() {
		return componentServiceKindIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getComponentServiceKindIntension_Conversation() {
		return (EReference)componentServiceKindIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceOfferIntension() {
		return serviceOfferIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceOfferIntension_Portbinding() {
		return (EReference)serviceOfferIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceOfferIntension_Propertybinding() {
		return (EReference)serviceOfferIntensionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceOfferIntension_Bindingport() {
		return (EReference)serviceOfferIntensionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceContractIntension() {
		return serviceContractIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceContractIntension_Commitmentoperation() {
		return (EReference)serviceContractIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceContractIntension_Propertybinding() {
		return (EReference)serviceContractIntensionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBusinessServiceKindIntension() {
		return businessServiceKindIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBusinessServiceKindIntension_Businessservicefeature() {
		return (EReference)businessServiceKindIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCooperationFacilityIntension() {
		return cooperationFacilityIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCooperationFacilityIntension_Facilityfeature() {
		return (EReference)cooperationFacilityIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBindingTypeIntension() {
		return bindingTypeIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBindingTypeIntension_Bindingporttype() {
		return (EReference)bindingTypeIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBusinessServiceIntension() {
		return businessServiceIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBusinessServiceIntension_Businessserviceproperty() {
		return (EReference)businessServiceIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getChannelTypeIntension() {
		return channelTypeIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getChannelTypeIntension_Channelfeature() {
		return (EReference)channelTypeIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceLiaisonIntension() {
		return serviceLiaisonIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceLiaisonIntension_Featurebinding() {
		return (EReference)serviceLiaisonIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEndpointBinding() {
		return endpointBindingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndpointBinding_Address() {
		return (EReference)endpointBindingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEndpointBinding_Bindingport() {
		return (EReference)endpointBindingEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceInterface() {
		return serviceInterfaceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceInterface_Exchange() {
		return (EReference)serviceInterfaceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDomainConceptIntension() {
		return domainConceptIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDomainConceptIntension_Features() {
		return (EReference)domainConceptIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceChannelIntension() {
		return serviceChannelIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceChannelIntension_Channelproperty() {
		return (EReference)serviceChannelIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceChannelIntension_Endpointbinding() {
		return (EReference)serviceChannelIntensionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceChannelIntension_Servicelink() {
		return (EReference)serviceChannelIntensionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceKindIntension() {
		return serviceKindIntensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceKindIntension_Servicefeature() {
		return (EReference)serviceKindIntensionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IntensionsFactory getIntensionsFactory() {
		return (IntensionsFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		informationEntityKindIntensionEClass = createEClass(INFORMATION_ENTITY_KIND_INTENSION);
		createEReference(informationEntityKindIntensionEClass, INFORMATION_ENTITY_KIND_INTENSION__INFORMATIONFEATURE);

		entityKindIntensionEClass = createEClass(ENTITY_KIND_INTENSION);
		createEReference(entityKindIntensionEClass, ENTITY_KIND_INTENSION__FEATURE);

		conceptIntensionEClass = createEClass(CONCEPT_INTENSION);
		createEReference(conceptIntensionEClass, CONCEPT_INTENSION__ELEMENTS);

		businessDocumentKindIntensionEClass = createEClass(BUSINESS_DOCUMENT_KIND_INTENSION);
		createEReference(businessDocumentKindIntensionEClass, BUSINESS_DOCUMENT_KIND_INTENSION__DOCUMENTTYPE);

		serviceEndpointKindIntensionEClass = createEClass(SERVICE_ENDPOINT_KIND_INTENSION);

		endpointKindIntensionEClass = createEClass(ENDPOINT_KIND_INTENSION);
		createEReference(endpointKindIntensionEClass, ENDPOINT_KIND_INTENSION__ENDPOINTFEATURE);
		createEReference(endpointKindIntensionEClass, ENDPOINT_KIND_INTENSION__ADDRESSKIND);

		legalEntityKindIntensionEClass = createEClass(LEGAL_ENTITY_KIND_INTENSION);
		createEReference(legalEntityKindIntensionEClass, LEGAL_ENTITY_KIND_INTENSION__COOPERATIVEFEATURE);

		informationEntityIntensionEClass = createEClass(INFORMATION_ENTITY_INTENSION);
		createEReference(informationEntityIntensionEClass, INFORMATION_ENTITY_INTENSION__INFORMATIONPROPERTY);

		entityIntensionEClass = createEClass(ENTITY_INTENSION);
		createEReference(entityIntensionEClass, ENTITY_INTENSION__PROPERTY);

		legalEntityIntensionEClass = createEClass(LEGAL_ENTITY_INTENSION);
		createEReference(legalEntityIntensionEClass, LEGAL_ENTITY_INTENSION__COOPERATIVEPROPERTY);

		businessDocumentIntensionEClass = createEClass(BUSINESS_DOCUMENT_INTENSION);
		createEReference(businessDocumentIntensionEClass, BUSINESS_DOCUMENT_INTENSION__ELEMENT);

		endpointEntityIntensionEClass = createEClass(ENDPOINT_ENTITY_INTENSION);
		createEReference(endpointEntityIntensionEClass, ENDPOINT_ENTITY_INTENSION__ENDPOINTPROPERTY);
		createEReference(endpointEntityIntensionEClass, ENDPOINT_ENTITY_INTENSION__ADDRESS);

		serviceIntensionEClass = createEClass(SERVICE_INTENSION);
		createEReference(serviceIntensionEClass, SERVICE_INTENSION__SERVICEPROPERTY);

		componentServiceIntensionEClass = createEClass(COMPONENT_SERVICE_INTENSION);
		createEReference(componentServiceIntensionEClass, COMPONENT_SERVICE_INTENSION__COMPONENTSERVICEPROPERTY);
		createEReference(componentServiceIntensionEClass, COMPONENT_SERVICE_INTENSION__EXCHANGE);

		messageExchangeEClass = createEClass(MESSAGE_EXCHANGE);
		createEReference(messageExchangeEClass, MESSAGE_EXCHANGE__OPERATIONS);

		serviceEndpointIntensionEClass = createEClass(SERVICE_ENDPOINT_INTENSION);

		componentServiceKindIntensionEClass = createEClass(COMPONENT_SERVICE_KIND_INTENSION);
		createEReference(componentServiceKindIntensionEClass, COMPONENT_SERVICE_KIND_INTENSION__CONVERSATION);

		serviceOfferIntensionEClass = createEClass(SERVICE_OFFER_INTENSION);
		createEReference(serviceOfferIntensionEClass, SERVICE_OFFER_INTENSION__PORTBINDING);
		createEReference(serviceOfferIntensionEClass, SERVICE_OFFER_INTENSION__PROPERTYBINDING);
		createEReference(serviceOfferIntensionEClass, SERVICE_OFFER_INTENSION__BINDINGPORT);

		serviceContractIntensionEClass = createEClass(SERVICE_CONTRACT_INTENSION);
		createEReference(serviceContractIntensionEClass, SERVICE_CONTRACT_INTENSION__COMMITMENTOPERATION);
		createEReference(serviceContractIntensionEClass, SERVICE_CONTRACT_INTENSION__PROPERTYBINDING);

		businessServiceKindIntensionEClass = createEClass(BUSINESS_SERVICE_KIND_INTENSION);
		createEReference(businessServiceKindIntensionEClass, BUSINESS_SERVICE_KIND_INTENSION__BUSINESSSERVICEFEATURE);

		cooperationFacilityIntensionEClass = createEClass(COOPERATION_FACILITY_INTENSION);
		createEReference(cooperationFacilityIntensionEClass, COOPERATION_FACILITY_INTENSION__FACILITYFEATURE);

		bindingTypeIntensionEClass = createEClass(BINDING_TYPE_INTENSION);
		createEReference(bindingTypeIntensionEClass, BINDING_TYPE_INTENSION__BINDINGPORTTYPE);

		businessServiceIntensionEClass = createEClass(BUSINESS_SERVICE_INTENSION);
		createEReference(businessServiceIntensionEClass, BUSINESS_SERVICE_INTENSION__BUSINESSSERVICEPROPERTY);

		channelTypeIntensionEClass = createEClass(CHANNEL_TYPE_INTENSION);
		createEReference(channelTypeIntensionEClass, CHANNEL_TYPE_INTENSION__CHANNELFEATURE);

		serviceLiaisonIntensionEClass = createEClass(SERVICE_LIAISON_INTENSION);
		createEReference(serviceLiaisonIntensionEClass, SERVICE_LIAISON_INTENSION__FEATUREBINDING);

		endpointBindingEClass = createEClass(ENDPOINT_BINDING);
		createEReference(endpointBindingEClass, ENDPOINT_BINDING__ADDRESS);
		createEReference(endpointBindingEClass, ENDPOINT_BINDING__BINDINGPORT);

		serviceInterfaceEClass = createEClass(SERVICE_INTERFACE);
		createEReference(serviceInterfaceEClass, SERVICE_INTERFACE__EXCHANGE);

		domainConceptIntensionEClass = createEClass(DOMAIN_CONCEPT_INTENSION);
		createEReference(domainConceptIntensionEClass, DOMAIN_CONCEPT_INTENSION__FEATURES);

		serviceChannelIntensionEClass = createEClass(SERVICE_CHANNEL_INTENSION);
		createEReference(serviceChannelIntensionEClass, SERVICE_CHANNEL_INTENSION__CHANNELPROPERTY);
		createEReference(serviceChannelIntensionEClass, SERVICE_CHANNEL_INTENSION__ENDPOINTBINDING);
		createEReference(serviceChannelIntensionEClass, SERVICE_CHANNEL_INTENSION__SERVICELINK);

		serviceKindIntensionEClass = createEClass(SERVICE_KIND_INTENSION);
		createEReference(serviceKindIntensionEClass, SERVICE_KIND_INTENSION__SERVICEFEATURE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		FunctionalfeaturesPackage theFunctionalfeaturesPackage = (FunctionalfeaturesPackage)EPackage.Registry.INSTANCE.getEPackage(FunctionalfeaturesPackage.eNS_URI);
		FeaturesPackage theFeaturesPackage = (FeaturesPackage)EPackage.Registry.INSTANCE.getEPackage(FeaturesPackage.eNS_URI);
		DomainontologyPackage theDomainontologyPackage = (DomainontologyPackage)EPackage.Registry.INSTANCE.getEPackage(DomainontologyPackage.eNS_URI);
		EcosystemintensionmodelPackage theEcosystemintensionmodelPackage = (EcosystemintensionmodelPackage)EPackage.Registry.INSTANCE.getEPackage(EcosystemintensionmodelPackage.eNS_URI);
		SystemsPackage theSystemsPackage = (SystemsPackage)EPackage.Registry.INSTANCE.getEPackage(SystemsPackage.eNS_URI);
		CooperativefeaturesPackage theCooperativefeaturesPackage = (CooperativefeaturesPackage)EPackage.Registry.INSTANCE.getEPackage(CooperativefeaturesPackage.eNS_URI);
		FunctionalpropertiesPackage theFunctionalpropertiesPackage = (FunctionalpropertiesPackage)EPackage.Registry.INSTANCE.getEPackage(FunctionalpropertiesPackage.eNS_URI);
		PropertiesPackage thePropertiesPackage = (PropertiesPackage)EPackage.Registry.INSTANCE.getEPackage(PropertiesPackage.eNS_URI);
		CooperativepropertiesPackage theCooperativepropertiesPackage = (CooperativepropertiesPackage)EPackage.Registry.INSTANCE.getEPackage(CooperativepropertiesPackage.eNS_URI);
		EcosystemmodelPackage theEcosystemmodelPackage = (EcosystemmodelPackage)EPackage.Registry.INSTANCE.getEPackage(EcosystemmodelPackage.eNS_URI);
		BindingsPackage theBindingsPackage = (BindingsPackage)EPackage.Registry.INSTANCE.getEPackage(BindingsPackage.eNS_URI);
		FacilitypropertiesPackage theFacilitypropertiesPackage = (FacilitypropertiesPackage)EPackage.Registry.INSTANCE.getEPackage(FacilitypropertiesPackage.eNS_URI);
		FacilityfeaturesPackage theFacilityfeaturesPackage = (FacilityfeaturesPackage)EPackage.Registry.INSTANCE.getEPackage(FacilityfeaturesPackage.eNS_URI);

		// Add supertypes to classes
		informationEntityKindIntensionEClass.getESuperTypes().add(this.getEntityKindIntension());
		entityKindIntensionEClass.getESuperTypes().add(this.getConceptIntension());
		conceptIntensionEClass.getESuperTypes().add(theDomainontologyPackage.getDomainOntologyElement());
		conceptIntensionEClass.getESuperTypes().add(theEcosystemintensionmodelPackage.getExtendableElement());
		conceptIntensionEClass.getESuperTypes().add(theSystemsPackage.getIntensionalSystem());
		businessDocumentKindIntensionEClass.getESuperTypes().add(this.getInformationEntityKindIntension());
		serviceEndpointKindIntensionEClass.getESuperTypes().add(this.getEndpointKindIntension());
		endpointKindIntensionEClass.getESuperTypes().add(this.getEntityKindIntension());
		legalEntityKindIntensionEClass.getESuperTypes().add(this.getEntityKindIntension());
		informationEntityIntensionEClass.getESuperTypes().add(this.getEntityIntension());
		entityIntensionEClass.getESuperTypes().add(this.getConceptIntension());
		legalEntityIntensionEClass.getESuperTypes().add(this.getEntityIntension());
		businessDocumentIntensionEClass.getESuperTypes().add(this.getInformationEntityIntension());
		endpointEntityIntensionEClass.getESuperTypes().add(this.getEntityIntension());
		serviceIntensionEClass.getESuperTypes().add(this.getEntityIntension());
		componentServiceIntensionEClass.getESuperTypes().add(this.getServiceIntension());
		messageExchangeEClass.getESuperTypes().add(theFunctionalpropertiesPackage.getComponentServiceProperty());
		serviceEndpointIntensionEClass.getESuperTypes().add(this.getEndpointEntityIntension());
		componentServiceKindIntensionEClass.getESuperTypes().add(this.getServiceKindIntension());
		serviceOfferIntensionEClass.getESuperTypes().add(this.getConceptIntension());
		serviceContractIntensionEClass.getESuperTypes().add(this.getConceptIntension());
		businessServiceKindIntensionEClass.getESuperTypes().add(this.getServiceKindIntension());
		cooperationFacilityIntensionEClass.getESuperTypes().add(this.getConceptIntension());
		bindingTypeIntensionEClass.getESuperTypes().add(this.getCooperationFacilityIntension());
		businessServiceIntensionEClass.getESuperTypes().add(this.getServiceIntension());
		channelTypeIntensionEClass.getESuperTypes().add(this.getCooperationFacilityIntension());
		serviceLiaisonIntensionEClass.getESuperTypes().add(this.getConceptIntension());
		endpointBindingEClass.getESuperTypes().add(theBindingsPackage.getPropertyBinding());
		serviceInterfaceEClass.getESuperTypes().add(theEcosystemintensionmodelPackage.getStructuralElement());
		domainConceptIntensionEClass.getESuperTypes().add(this.getConceptIntension());
		serviceChannelIntensionEClass.getESuperTypes().add(this.getConceptIntension());
		serviceKindIntensionEClass.getESuperTypes().add(this.getEntityKindIntension());

		// Initialize classes and features; add operations and parameters
		initEClass(informationEntityKindIntensionEClass, InformationEntityKindIntension.class, "InformationEntityKindIntension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInformationEntityKindIntension_Informationfeature(), theFunctionalfeaturesPackage.getInformationFeature(), null, "informationfeature", null, 1, -1, InformationEntityKindIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(entityKindIntensionEClass, EntityKindIntension.class, "EntityKindIntension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEntityKindIntension_Feature(), theFeaturesPackage.getFeature(), null, "feature", null, 0, -1, EntityKindIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(conceptIntensionEClass, ConceptIntension.class, "ConceptIntension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getConceptIntension_Elements(), theEcosystemintensionmodelPackage.getInstantiatableElement(), null, "elements", null, 0, -1, ConceptIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(businessDocumentKindIntensionEClass, BusinessDocumentKindIntension.class, "BusinessDocumentKindIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBusinessDocumentKindIntension_Documenttype(), theFunctionalfeaturesPackage.getBusinessDocumentType(), null, "documenttype", null, 1, 1, BusinessDocumentKindIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(serviceEndpointKindIntensionEClass, ServiceEndpointKindIntension.class, "ServiceEndpointKindIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(endpointKindIntensionEClass, EndpointKindIntension.class, "EndpointKindIntension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEndpointKindIntension_Endpointfeature(), theFunctionalfeaturesPackage.getEndpointFeature(), null, "endpointfeature", null, 1, -1, EndpointKindIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getEndpointKindIntension_Addresskind(), theFunctionalfeaturesPackage.getEndpointAddressKind(), null, "addresskind", null, 1, 1, EndpointKindIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(legalEntityKindIntensionEClass, LegalEntityKindIntension.class, "LegalEntityKindIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLegalEntityKindIntension_Cooperativefeature(), theCooperativefeaturesPackage.getCooperativeFeature(), null, "cooperativefeature", null, 1, -1, LegalEntityKindIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(informationEntityIntensionEClass, InformationEntityIntension.class, "InformationEntityIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInformationEntityIntension_Informationproperty(), theFunctionalpropertiesPackage.getInformationProperty(), null, "informationproperty", null, 1, -1, InformationEntityIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(entityIntensionEClass, EntityIntension.class, "EntityIntension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEntityIntension_Property(), thePropertiesPackage.getProperty(), null, "property", null, 0, -1, EntityIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(legalEntityIntensionEClass, LegalEntityIntension.class, "LegalEntityIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLegalEntityIntension_Cooperativeproperty(), theCooperativepropertiesPackage.getCooperativeProperty(), null, "cooperativeproperty", null, 0, -1, LegalEntityIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(businessDocumentIntensionEClass, BusinessDocumentIntension.class, "BusinessDocumentIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBusinessDocumentIntension_Element(), theFunctionalpropertiesPackage.getBusinessDocumentElement(), null, "element", null, 1, 1, BusinessDocumentIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(endpointEntityIntensionEClass, EndpointEntityIntension.class, "EndpointEntityIntension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEndpointEntityIntension_Endpointproperty(), theFunctionalpropertiesPackage.getEndpointProperty(), null, "endpointproperty", null, 0, -1, EndpointEntityIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getEndpointEntityIntension_Address(), theFunctionalpropertiesPackage.getEndpointAddress(), null, "address", null, 1, 1, EndpointEntityIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(serviceIntensionEClass, ServiceIntension.class, "ServiceIntension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceIntension_Serviceproperty(), theFunctionalpropertiesPackage.getServiceProperty(), null, "serviceproperty", null, 0, -1, ServiceIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(componentServiceIntensionEClass, ComponentServiceIntension.class, "ComponentServiceIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getComponentServiceIntension_Componentserviceproperty(), theFunctionalpropertiesPackage.getComponentServiceProperty(), null, "componentserviceproperty", null, 0, -1, ComponentServiceIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getComponentServiceIntension_Exchange(), this.getMessageExchange(), null, "exchange", null, 1, -1, ComponentServiceIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(messageExchangeEClass, MessageExchange.class, "MessageExchange", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMessageExchange_Operations(), theEcosystemmodelPackage.getServiceOperation(), null, "operations", null, 1, -1, MessageExchange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(serviceEndpointIntensionEClass, ServiceEndpointIntension.class, "ServiceEndpointIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(componentServiceKindIntensionEClass, ComponentServiceKindIntension.class, "ComponentServiceKindIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getComponentServiceKindIntension_Conversation(), theEcosystemmodelPackage.getServiceConversation(), null, "conversation", null, 1, -1, ComponentServiceKindIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(serviceOfferIntensionEClass, ServiceOfferIntension.class, "ServiceOfferIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceOfferIntension_Portbinding(), theBindingsPackage.getPortBinding(), null, "portbinding", null, 1, -1, ServiceOfferIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getServiceOfferIntension_Propertybinding(), theBindingsPackage.getPropertyBinding(), null, "propertybinding", null, 0, -1, ServiceOfferIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getServiceOfferIntension_Bindingport(), theFacilitypropertiesPackage.getBindingPort(), null, "bindingport", null, 1, -1, ServiceOfferIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(serviceContractIntensionEClass, ServiceContractIntension.class, "ServiceContractIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceContractIntension_Commitmentoperation(), theEcosystemintensionmodelPackage.getCommitmentOperation(), null, "commitmentoperation", null, 0, -1, ServiceContractIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getServiceContractIntension_Propertybinding(), theBindingsPackage.getPropertyBinding(), null, "propertybinding", null, 0, -1, ServiceContractIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(businessServiceKindIntensionEClass, BusinessServiceKindIntension.class, "BusinessServiceKindIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBusinessServiceKindIntension_Businessservicefeature(), theFunctionalfeaturesPackage.getBusinessServiceFeature(), null, "businessservicefeature", null, 0, -1, BusinessServiceKindIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(cooperationFacilityIntensionEClass, CooperationFacilityIntension.class, "CooperationFacilityIntension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCooperationFacilityIntension_Facilityfeature(), theFacilityfeaturesPackage.getFacilityFeature(), null, "facilityfeature", null, 1, -1, CooperationFacilityIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(bindingTypeIntensionEClass, BindingTypeIntension.class, "BindingTypeIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBindingTypeIntension_Bindingporttype(), theFacilityfeaturesPackage.getBindingPortType(), null, "bindingporttype", null, 1, -1, BindingTypeIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(businessServiceIntensionEClass, BusinessServiceIntension.class, "BusinessServiceIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBusinessServiceIntension_Businessserviceproperty(), theFunctionalpropertiesPackage.getBusinessServiceProperty(), null, "businessserviceproperty", null, 0, -1, BusinessServiceIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(channelTypeIntensionEClass, ChannelTypeIntension.class, "ChannelTypeIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getChannelTypeIntension_Channelfeature(), theFacilityfeaturesPackage.getChannelFeature(), null, "channelfeature", null, 1, -1, ChannelTypeIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(serviceLiaisonIntensionEClass, ServiceLiaisonIntension.class, "ServiceLiaisonIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceLiaisonIntension_Featurebinding(), theBindingsPackage.getFeatureBinding(), null, "featurebinding", null, 0, -1, ServiceLiaisonIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(endpointBindingEClass, EndpointBinding.class, "EndpointBinding", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEndpointBinding_Address(), theFunctionalpropertiesPackage.getEndpointAddress(), null, "address", null, 1, 1, EndpointBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getEndpointBinding_Bindingport(), theFacilitypropertiesPackage.getBindingPort(), null, "bindingport", null, 1, 1, EndpointBinding.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(serviceInterfaceEClass, ServiceInterface.class, "ServiceInterface", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceInterface_Exchange(), this.getMessageExchange(), null, "exchange", null, 1, -1, ServiceInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(domainConceptIntensionEClass, DomainConceptIntension.class, "DomainConceptIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDomainConceptIntension_Features(), theFeaturesPackage.getDomainFeature(), null, "features", null, 0, -1, DomainConceptIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(serviceChannelIntensionEClass, ServiceChannelIntension.class, "ServiceChannelIntension", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceChannelIntension_Channelproperty(), theFacilitypropertiesPackage.getFacilityProperty(), null, "channelproperty", null, 0, -1, ServiceChannelIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getServiceChannelIntension_Endpointbinding(), this.getEndpointBinding(), null, "endpointbinding", null, 1, -1, ServiceChannelIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getServiceChannelIntension_Servicelink(), theEcosystemintensionmodelPackage.getServiceLink(), null, "servicelink", null, 1, -1, ServiceChannelIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(serviceKindIntensionEClass, ServiceKindIntension.class, "ServiceKindIntension", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceKindIntension_Servicefeature(), theFunctionalfeaturesPackage.getServiceFeature(), null, "servicefeature", null, 0, -1, ServiceKindIntension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
	}

} //IntensionsPackageImpl
