/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl;

import java.util.Collection;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.impl.InstantiatableElementImpl;

import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.BusinessAction;
import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.BusinessTransaction;
import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.ChoreographiesPackage;
import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.ServiceChoreography;
import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.ServiceConnection;

import org.cinco.metamodel.ecosystem.foundations.behaviour.Action;
import org.cinco.metamodel.ecosystem.foundations.behaviour.Behaviour;
import org.cinco.metamodel.ecosystem.foundations.behaviour.BehaviourPackage;
import org.cinco.metamodel.ecosystem.foundations.behaviour.Choice;
import org.cinco.metamodel.ecosystem.foundations.behaviour.Choreography;
import org.cinco.metamodel.ecosystem.foundations.behaviour.ChoreographyRole;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Service Choreography</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.ServiceChoreographyImpl#getEvents <em>Events</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.ServiceChoreographyImpl#getChoice <em>Choice</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.ServiceChoreographyImpl#getRoles <em>Roles</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.ServiceChoreographyImpl#getActions <em>Actions</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.ServiceChoreographyImpl#getConnections <em>Connections</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.ServiceChoreographyImpl#getTransactions <em>Transactions</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ServiceChoreographyImpl extends InstantiatableElementImpl implements ServiceChoreography {
	/**
	 * The cached value of the '{@link #getEvents() <em>Events</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvents()
	 * @generated
	 * @ordered
	 */
	protected EList events;

	/**
	 * The cached value of the '{@link #getChoice() <em>Choice</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getChoice()
	 * @generated
	 * @ordered
	 */
	protected EList choice;

	/**
	 * The cached value of the '{@link #getRoles() <em>Roles</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoles()
	 * @generated
	 * @ordered
	 */
	protected EList roles;

	/**
	 * The cached value of the '{@link #getActions() <em>Actions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActions()
	 * @generated
	 * @ordered
	 */
	protected EList actions;

	/**
	 * The cached value of the '{@link #getConnections() <em>Connections</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnections()
	 * @generated
	 * @ordered
	 */
	protected EList connections;

	/**
	 * The cached value of the '{@link #getTransactions() <em>Transactions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTransactions()
	 * @generated
	 * @ordered
	 */
	protected EList transactions;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ServiceChoreographyImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ChoreographiesPackage.Literals.SERVICE_CHOREOGRAPHY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getEvents() {
		if (events == null) {
			events = new EObjectContainmentEList(Action.class, this, ChoreographiesPackage.SERVICE_CHOREOGRAPHY__EVENTS);
		}
		return events;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getChoice() {
		if (choice == null) {
			choice = new EObjectResolvingEList(Choice.class, this, ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CHOICE);
		}
		return choice;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getRoles() {
		if (roles == null) {
			roles = new EObjectContainmentEList(ChoreographyRole.class, this, ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ROLES);
		}
		return roles;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getActions() {
		if (actions == null) {
			actions = new EObjectContainmentEList(BusinessAction.class, this, ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ACTIONS);
		}
		return actions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getConnections() {
		if (connections == null) {
			connections = new EObjectContainmentEList(ServiceConnection.class, this, ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CONNECTIONS);
		}
		return connections;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getTransactions() {
		if (transactions == null) {
			transactions = new EObjectContainmentEList(BusinessTransaction.class, this, ChoreographiesPackage.SERVICE_CHOREOGRAPHY__TRANSACTIONS);
		}
		return transactions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__EVENTS:
				return ((InternalEList)getEvents()).basicRemove(otherEnd, msgs);
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ROLES:
				return ((InternalEList)getRoles()).basicRemove(otherEnd, msgs);
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ACTIONS:
				return ((InternalEList)getActions()).basicRemove(otherEnd, msgs);
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CONNECTIONS:
				return ((InternalEList)getConnections()).basicRemove(otherEnd, msgs);
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__TRANSACTIONS:
				return ((InternalEList)getTransactions()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__EVENTS:
				return getEvents();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CHOICE:
				return getChoice();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ROLES:
				return getRoles();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ACTIONS:
				return getActions();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CONNECTIONS:
				return getConnections();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__TRANSACTIONS:
				return getTransactions();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__EVENTS:
				getEvents().clear();
				getEvents().addAll((Collection)newValue);
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CHOICE:
				getChoice().clear();
				getChoice().addAll((Collection)newValue);
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ROLES:
				getRoles().clear();
				getRoles().addAll((Collection)newValue);
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ACTIONS:
				getActions().clear();
				getActions().addAll((Collection)newValue);
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CONNECTIONS:
				getConnections().clear();
				getConnections().addAll((Collection)newValue);
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__TRANSACTIONS:
				getTransactions().clear();
				getTransactions().addAll((Collection)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__EVENTS:
				getEvents().clear();
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CHOICE:
				getChoice().clear();
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ROLES:
				getRoles().clear();
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ACTIONS:
				getActions().clear();
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CONNECTIONS:
				getConnections().clear();
				return;
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__TRANSACTIONS:
				getTransactions().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__EVENTS:
				return events != null && !events.isEmpty();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CHOICE:
				return choice != null && !choice.isEmpty();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ROLES:
				return roles != null && !roles.isEmpty();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ACTIONS:
				return actions != null && !actions.isEmpty();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CONNECTIONS:
				return connections != null && !connections.isEmpty();
			case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__TRANSACTIONS:
				return transactions != null && !transactions.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
		if (baseClass == Behaviour.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == org.cinco.metamodel.ecosystem.foundations.behaviour.Process.class) {
			switch (derivedFeatureID) {
				case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__EVENTS: return BehaviourPackage.PROCESS__EVENTS;
				case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CHOICE: return BehaviourPackage.PROCESS__CHOICE;
				default: return -1;
			}
		}
		if (baseClass == Choreography.class) {
			switch (derivedFeatureID) {
				case ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ROLES: return BehaviourPackage.CHOREOGRAPHY__ROLES;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
		if (baseClass == Behaviour.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == org.cinco.metamodel.ecosystem.foundations.behaviour.Process.class) {
			switch (baseFeatureID) {
				case BehaviourPackage.PROCESS__EVENTS: return ChoreographiesPackage.SERVICE_CHOREOGRAPHY__EVENTS;
				case BehaviourPackage.PROCESS__CHOICE: return ChoreographiesPackage.SERVICE_CHOREOGRAPHY__CHOICE;
				default: return -1;
			}
		}
		if (baseClass == Choreography.class) {
			switch (baseFeatureID) {
				case BehaviourPackage.CHOREOGRAPHY__ROLES: return ChoreographiesPackage.SERVICE_CHOREOGRAPHY__ROLES;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} //ServiceChoreographyImpl
