/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.impl;

import java.util.Collection;

import org.cinco.metamodel.ecosystem.domainontology.contracting.ContractingPackage;
import org.cinco.metamodel.ecosystem.domainontology.contracting.ServiceLiaison;

import org.cinco.metamodel.ecosystem.ecosystemmodel.impl.EcosystemElementImpl;

import org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.Actor;
import org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.LifeCyclePhase;
import org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.LifeCycleProduct;
import org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.LifecyclePackage;

import org.cinco.metamodel.ecosystem.foundations.behaviour.Behaviour;
import org.cinco.metamodel.ecosystem.foundations.behaviour.BehaviourPackage;
import org.cinco.metamodel.ecosystem.foundations.behaviour.Event;
import org.cinco.metamodel.ecosystem.foundations.behaviour.Phase;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Life Cycle Phase</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.impl.LifeCyclePhaseImpl#getPredecessor <em>Predecessor</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.impl.LifeCyclePhaseImpl#getBehaviour <em>Behaviour</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.impl.LifeCyclePhaseImpl#getOutput <em>Output</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.impl.LifeCyclePhaseImpl#getInput <em>Input</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.impl.LifeCyclePhaseImpl#getActor <em>Actor</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.lifecycle.impl.LifeCyclePhaseImpl#getLiaison <em>Liaison</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class LifeCyclePhaseImpl extends EcosystemElementImpl implements LifeCyclePhase {
	/**
	 * The cached value of the '{@link #getPredecessor() <em>Predecessor</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPredecessor()
	 * @generated
	 * @ordered
	 */
	protected EList predecessor;

	/**
	 * The cached value of the '{@link #getBehaviour() <em>Behaviour</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBehaviour()
	 * @generated
	 * @ordered
	 */
	protected Behaviour behaviour;

	/**
	 * The cached value of the '{@link #getOutput() <em>Output</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutput()
	 * @generated
	 * @ordered
	 */
	protected EList output;

	/**
	 * The cached value of the '{@link #getInput() <em>Input</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInput()
	 * @generated
	 * @ordered
	 */
	protected EList input;

	/**
	 * The cached value of the '{@link #getActor() <em>Actor</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActor()
	 * @generated
	 * @ordered
	 */
	protected EList actor;

	/**
	 * The cached value of the '{@link #getLiaison() <em>Liaison</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLiaison()
	 * @generated
	 * @ordered
	 */
	protected ServiceLiaison liaison;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LifeCyclePhaseImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return LifecyclePackage.Literals.LIFE_CYCLE_PHASE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getPredecessor() {
		if (predecessor == null) {
			predecessor = new EObjectResolvingEList(Event.class, this, LifecyclePackage.LIFE_CYCLE_PHASE__PREDECESSOR);
		}
		return predecessor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Behaviour getBehaviour() {
		if (behaviour != null && behaviour.eIsProxy()) {
			InternalEObject oldBehaviour = (InternalEObject)behaviour;
			behaviour = (Behaviour)eResolveProxy(oldBehaviour);
			if (behaviour != oldBehaviour) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, LifecyclePackage.LIFE_CYCLE_PHASE__BEHAVIOUR, oldBehaviour, behaviour));
			}
		}
		return behaviour;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Behaviour basicGetBehaviour() {
		return behaviour;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBehaviour(Behaviour newBehaviour) {
		Behaviour oldBehaviour = behaviour;
		behaviour = newBehaviour;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, LifecyclePackage.LIFE_CYCLE_PHASE__BEHAVIOUR, oldBehaviour, behaviour));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getOutput() {
		if (output == null) {
			output = new EObjectResolvingEList(LifeCycleProduct.class, this, LifecyclePackage.LIFE_CYCLE_PHASE__OUTPUT);
		}
		return output;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getInput() {
		if (input == null) {
			input = new EObjectResolvingEList(LifeCycleProduct.class, this, LifecyclePackage.LIFE_CYCLE_PHASE__INPUT);
		}
		return input;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getActor() {
		if (actor == null) {
			actor = new EObjectWithInverseResolvingEList.ManyInverse(Actor.class, this, LifecyclePackage.LIFE_CYCLE_PHASE__ACTOR, LifecyclePackage.ACTOR__PARTICIPATES);
		}
		return actor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServiceLiaison getLiaison() {
		if (liaison != null && liaison.eIsProxy()) {
			InternalEObject oldLiaison = (InternalEObject)liaison;
			liaison = (ServiceLiaison)eResolveProxy(oldLiaison);
			if (liaison != oldLiaison) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, LifecyclePackage.LIFE_CYCLE_PHASE__LIAISON, oldLiaison, liaison));
			}
		}
		return liaison;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServiceLiaison basicGetLiaison() {
		return liaison;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLiaison(ServiceLiaison newLiaison, NotificationChain msgs) {
		ServiceLiaison oldLiaison = liaison;
		liaison = newLiaison;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, LifecyclePackage.LIFE_CYCLE_PHASE__LIAISON, oldLiaison, newLiaison);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLiaison(ServiceLiaison newLiaison) {
		if (newLiaison != liaison) {
			NotificationChain msgs = null;
			if (liaison != null)
				msgs = ((InternalEObject)liaison).eInverseRemove(this, ContractingPackage.SERVICE_LIAISON__PHASE, ServiceLiaison.class, msgs);
			if (newLiaison != null)
				msgs = ((InternalEObject)newLiaison).eInverseAdd(this, ContractingPackage.SERVICE_LIAISON__PHASE, ServiceLiaison.class, msgs);
			msgs = basicSetLiaison(newLiaison, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, LifecyclePackage.LIFE_CYCLE_PHASE__LIAISON, newLiaison, newLiaison));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case LifecyclePackage.LIFE_CYCLE_PHASE__ACTOR:
				return ((InternalEList)getActor()).basicAdd(otherEnd, msgs);
			case LifecyclePackage.LIFE_CYCLE_PHASE__LIAISON:
				if (liaison != null)
					msgs = ((InternalEObject)liaison).eInverseRemove(this, ContractingPackage.SERVICE_LIAISON__PHASE, ServiceLiaison.class, msgs);
				return basicSetLiaison((ServiceLiaison)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case LifecyclePackage.LIFE_CYCLE_PHASE__ACTOR:
				return ((InternalEList)getActor()).basicRemove(otherEnd, msgs);
			case LifecyclePackage.LIFE_CYCLE_PHASE__LIAISON:
				return basicSetLiaison(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case LifecyclePackage.LIFE_CYCLE_PHASE__PREDECESSOR:
				return getPredecessor();
			case LifecyclePackage.LIFE_CYCLE_PHASE__BEHAVIOUR:
				if (resolve) return getBehaviour();
				return basicGetBehaviour();
			case LifecyclePackage.LIFE_CYCLE_PHASE__OUTPUT:
				return getOutput();
			case LifecyclePackage.LIFE_CYCLE_PHASE__INPUT:
				return getInput();
			case LifecyclePackage.LIFE_CYCLE_PHASE__ACTOR:
				return getActor();
			case LifecyclePackage.LIFE_CYCLE_PHASE__LIAISON:
				if (resolve) return getLiaison();
				return basicGetLiaison();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case LifecyclePackage.LIFE_CYCLE_PHASE__PREDECESSOR:
				getPredecessor().clear();
				getPredecessor().addAll((Collection)newValue);
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__BEHAVIOUR:
				setBehaviour((Behaviour)newValue);
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__OUTPUT:
				getOutput().clear();
				getOutput().addAll((Collection)newValue);
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__INPUT:
				getInput().clear();
				getInput().addAll((Collection)newValue);
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__ACTOR:
				getActor().clear();
				getActor().addAll((Collection)newValue);
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__LIAISON:
				setLiaison((ServiceLiaison)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case LifecyclePackage.LIFE_CYCLE_PHASE__PREDECESSOR:
				getPredecessor().clear();
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__BEHAVIOUR:
				setBehaviour((Behaviour)null);
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__OUTPUT:
				getOutput().clear();
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__INPUT:
				getInput().clear();
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__ACTOR:
				getActor().clear();
				return;
			case LifecyclePackage.LIFE_CYCLE_PHASE__LIAISON:
				setLiaison((ServiceLiaison)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case LifecyclePackage.LIFE_CYCLE_PHASE__PREDECESSOR:
				return predecessor != null && !predecessor.isEmpty();
			case LifecyclePackage.LIFE_CYCLE_PHASE__BEHAVIOUR:
				return behaviour != null;
			case LifecyclePackage.LIFE_CYCLE_PHASE__OUTPUT:
				return output != null && !output.isEmpty();
			case LifecyclePackage.LIFE_CYCLE_PHASE__INPUT:
				return input != null && !input.isEmpty();
			case LifecyclePackage.LIFE_CYCLE_PHASE__ACTOR:
				return actor != null && !actor.isEmpty();
			case LifecyclePackage.LIFE_CYCLE_PHASE__LIAISON:
				return liaison != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
		if (baseClass == Event.class) {
			switch (derivedFeatureID) {
				case LifecyclePackage.LIFE_CYCLE_PHASE__PREDECESSOR: return BehaviourPackage.EVENT__PREDECESSOR;
				case LifecyclePackage.LIFE_CYCLE_PHASE__BEHAVIOUR: return BehaviourPackage.EVENT__BEHAVIOUR;
				default: return -1;
			}
		}
		if (baseClass == Phase.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
		if (baseClass == Event.class) {
			switch (baseFeatureID) {
				case BehaviourPackage.EVENT__PREDECESSOR: return LifecyclePackage.LIFE_CYCLE_PHASE__PREDECESSOR;
				case BehaviourPackage.EVENT__BEHAVIOUR: return LifecyclePackage.LIFE_CYCLE_PHASE__BEHAVIOUR;
				default: return -1;
			}
		}
		if (baseClass == Phase.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} //LifeCyclePhaseImpl
