/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl;

import java.util.Collection;

import org.cinco.metamodel.ecosystem.domainontology.DomainontologyPackage;
import org.cinco.metamodel.ecosystem.domainontology.IdentifiedElement;
import org.cinco.metamodel.ecosystem.domainontology.Identifier;

import org.cinco.metamodel.ecosystem.ecosystemmodel.KnowledgeBase;

import org.cinco.metamodel.ecosystem.ecosystemmodel.impl.InfrastructureServiceImpl;

import org.cinco.metamodel.ecosystem.engineeringmodel.engineeringspace.EngineeringSpace;

import org.cinco.metamodel.ecosystem.foundations.models.ReferenceModel;

import org.cinco.metamodel.ecosystem.foundations.systems.DigitalSystem;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.KnowledgeManagementElement;

import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.KnowledgeItemSet;
import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.KnowledgeRelationshipType;
import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.KnowledgeRepository;
import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.ModelContainer;
import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.ModelRepository;
import org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.RepositoriesPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Knowledge Repository</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl.KnowledgeRepositoryImpl#getModeltype <em>Modeltype</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl.KnowledgeRepositoryImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl.KnowledgeRepositoryImpl#getIdentifier <em>Identifier</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl.KnowledgeRepositoryImpl#getRelationship <em>Relationship</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl.KnowledgeRepositoryImpl#getItemsets <em>Itemsets</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl.KnowledgeRepositoryImpl#getEngineeringspace <em>Engineeringspace</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.knowledgemanagementmodel.repositories.impl.KnowledgeRepositoryImpl#getKnowledgebase <em>Knowledgebase</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class KnowledgeRepositoryImpl extends InfrastructureServiceImpl implements KnowledgeRepository {
	/**
	 * The cached value of the '{@link #getModeltype() <em>Modeltype</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModeltype()
	 * @generated
	 * @ordered
	 */
	protected ReferenceModel modeltype;

	/**
	 * The cached value of the '{@link #getContainer() <em>Container</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainer()
	 * @generated
	 * @ordered
	 */
	protected ModelContainer container;

	/**
	 * The cached value of the '{@link #getIdentifier() <em>Identifier</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIdentifier()
	 * @generated
	 * @ordered
	 */
	protected Identifier identifier;

	/**
	 * The cached value of the '{@link #getRelationship() <em>Relationship</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRelationship()
	 * @generated
	 * @ordered
	 */
	protected EList relationship;

	/**
	 * The cached value of the '{@link #getItemsets() <em>Itemsets</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getItemsets()
	 * @generated
	 * @ordered
	 */
	protected EList itemsets;

	/**
	 * The cached value of the '{@link #getEngineeringspace() <em>Engineeringspace</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEngineeringspace()
	 * @generated
	 * @ordered
	 */
	protected EngineeringSpace engineeringspace;

	/**
	 * The cached value of the '{@link #getKnowledgebase() <em>Knowledgebase</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getKnowledgebase()
	 * @generated
	 * @ordered
	 */
	protected KnowledgeBase knowledgebase;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected KnowledgeRepositoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return RepositoriesPackage.Literals.KNOWLEDGE_REPOSITORY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ReferenceModel getModeltype() {
		if (modeltype != null && modeltype.eIsProxy()) {
			InternalEObject oldModeltype = (InternalEObject)modeltype;
			modeltype = (ReferenceModel)eResolveProxy(oldModeltype);
			if (modeltype != oldModeltype) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoriesPackage.KNOWLEDGE_REPOSITORY__MODELTYPE, oldModeltype, modeltype));
			}
		}
		return modeltype;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ReferenceModel basicGetModeltype() {
		return modeltype;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setModeltype(ReferenceModel newModeltype) {
		ReferenceModel oldModeltype = modeltype;
		modeltype = newModeltype;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoriesPackage.KNOWLEDGE_REPOSITORY__MODELTYPE, oldModeltype, modeltype));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelContainer getContainer() {
		return container;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetContainer(ModelContainer newContainer, NotificationChain msgs) {
		ModelContainer oldContainer = container;
		container = newContainer;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER, oldContainer, newContainer);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setContainer(ModelContainer newContainer) {
		if (newContainer != container) {
			NotificationChain msgs = null;
			if (container != null)
				msgs = ((InternalEObject)container).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER, null, msgs);
			if (newContainer != null)
				msgs = ((InternalEObject)newContainer).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER, null, msgs);
			msgs = basicSetContainer(newContainer, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER, newContainer, newContainer));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Identifier getIdentifier() {
		return identifier;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetIdentifier(Identifier newIdentifier, NotificationChain msgs) {
		Identifier oldIdentifier = identifier;
		identifier = newIdentifier;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER, oldIdentifier, newIdentifier);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIdentifier(Identifier newIdentifier) {
		if (newIdentifier != identifier) {
			NotificationChain msgs = null;
			if (identifier != null)
				msgs = ((InternalEObject)identifier).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER, null, msgs);
			if (newIdentifier != null)
				msgs = ((InternalEObject)newIdentifier).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER, null, msgs);
			msgs = basicSetIdentifier(newIdentifier, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER, newIdentifier, newIdentifier));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getRelationship() {
		if (relationship == null) {
			relationship = new EObjectResolvingEList(KnowledgeRelationshipType.class, this, RepositoriesPackage.KNOWLEDGE_REPOSITORY__RELATIONSHIP);
		}
		return relationship;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getItemsets() {
		if (itemsets == null) {
			itemsets = new EObjectContainmentEList(KnowledgeItemSet.class, this, RepositoriesPackage.KNOWLEDGE_REPOSITORY__ITEMSETS);
		}
		return itemsets;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EngineeringSpace getEngineeringspace() {
		if (engineeringspace != null && engineeringspace.eIsProxy()) {
			InternalEObject oldEngineeringspace = (InternalEObject)engineeringspace;
			engineeringspace = (EngineeringSpace)eResolveProxy(oldEngineeringspace);
			if (engineeringspace != oldEngineeringspace) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoriesPackage.KNOWLEDGE_REPOSITORY__ENGINEERINGSPACE, oldEngineeringspace, engineeringspace));
			}
		}
		return engineeringspace;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EngineeringSpace basicGetEngineeringspace() {
		return engineeringspace;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEngineeringspace(EngineeringSpace newEngineeringspace) {
		EngineeringSpace oldEngineeringspace = engineeringspace;
		engineeringspace = newEngineeringspace;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoriesPackage.KNOWLEDGE_REPOSITORY__ENGINEERINGSPACE, oldEngineeringspace, engineeringspace));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public KnowledgeBase getKnowledgebase() {
		if (knowledgebase != null && knowledgebase.eIsProxy()) {
			InternalEObject oldKnowledgebase = (InternalEObject)knowledgebase;
			knowledgebase = (KnowledgeBase)eResolveProxy(oldKnowledgebase);
			if (knowledgebase != oldKnowledgebase) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoriesPackage.KNOWLEDGE_REPOSITORY__KNOWLEDGEBASE, oldKnowledgebase, knowledgebase));
			}
		}
		return knowledgebase;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public KnowledgeBase basicGetKnowledgebase() {
		return knowledgebase;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setKnowledgebase(KnowledgeBase newKnowledgebase) {
		KnowledgeBase oldKnowledgebase = knowledgebase;
		knowledgebase = newKnowledgebase;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoriesPackage.KNOWLEDGE_REPOSITORY__KNOWLEDGEBASE, oldKnowledgebase, knowledgebase));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER:
				return basicSetContainer(null, msgs);
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER:
				return basicSetIdentifier(null, msgs);
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__ITEMSETS:
				return ((InternalEList)getItemsets()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__MODELTYPE:
				if (resolve) return getModeltype();
				return basicGetModeltype();
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER:
				return getContainer();
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER:
				return getIdentifier();
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__RELATIONSHIP:
				return getRelationship();
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__ITEMSETS:
				return getItemsets();
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__ENGINEERINGSPACE:
				if (resolve) return getEngineeringspace();
				return basicGetEngineeringspace();
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__KNOWLEDGEBASE:
				if (resolve) return getKnowledgebase();
				return basicGetKnowledgebase();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__MODELTYPE:
				setModeltype((ReferenceModel)newValue);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER:
				setContainer((ModelContainer)newValue);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER:
				setIdentifier((Identifier)newValue);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__RELATIONSHIP:
				getRelationship().clear();
				getRelationship().addAll((Collection)newValue);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__ITEMSETS:
				getItemsets().clear();
				getItemsets().addAll((Collection)newValue);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__ENGINEERINGSPACE:
				setEngineeringspace((EngineeringSpace)newValue);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__KNOWLEDGEBASE:
				setKnowledgebase((KnowledgeBase)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__MODELTYPE:
				setModeltype((ReferenceModel)null);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER:
				setContainer((ModelContainer)null);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER:
				setIdentifier((Identifier)null);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__RELATIONSHIP:
				getRelationship().clear();
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__ITEMSETS:
				getItemsets().clear();
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__ENGINEERINGSPACE:
				setEngineeringspace((EngineeringSpace)null);
				return;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__KNOWLEDGEBASE:
				setKnowledgebase((KnowledgeBase)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__MODELTYPE:
				return modeltype != null;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER:
				return container != null;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER:
				return identifier != null;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__RELATIONSHIP:
				return relationship != null && !relationship.isEmpty();
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__ITEMSETS:
				return itemsets != null && !itemsets.isEmpty();
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__ENGINEERINGSPACE:
				return engineeringspace != null;
			case RepositoriesPackage.KNOWLEDGE_REPOSITORY__KNOWLEDGEBASE:
				return knowledgebase != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
		if (baseClass == DigitalSystem.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ModelRepository.class) {
			switch (derivedFeatureID) {
				case RepositoriesPackage.KNOWLEDGE_REPOSITORY__MODELTYPE: return RepositoriesPackage.MODEL_REPOSITORY__MODELTYPE;
				case RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER: return RepositoriesPackage.MODEL_REPOSITORY__CONTAINER;
				default: return -1;
			}
		}
		if (baseClass == IdentifiedElement.class) {
			switch (derivedFeatureID) {
				case RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER: return DomainontologyPackage.IDENTIFIED_ELEMENT__IDENTIFIER;
				default: return -1;
			}
		}
		if (baseClass == KnowledgeManagementElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
		if (baseClass == DigitalSystem.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ModelRepository.class) {
			switch (baseFeatureID) {
				case RepositoriesPackage.MODEL_REPOSITORY__MODELTYPE: return RepositoriesPackage.KNOWLEDGE_REPOSITORY__MODELTYPE;
				case RepositoriesPackage.MODEL_REPOSITORY__CONTAINER: return RepositoriesPackage.KNOWLEDGE_REPOSITORY__CONTAINER;
				default: return -1;
			}
		}
		if (baseClass == IdentifiedElement.class) {
			switch (baseFeatureID) {
				case DomainontologyPackage.IDENTIFIED_ELEMENT__IDENTIFIER: return RepositoriesPackage.KNOWLEDGE_REPOSITORY__IDENTIFIER;
				default: return -1;
			}
		}
		if (baseClass == KnowledgeManagementElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} //KnowledgeRepositoryImpl
