/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.osgi.xmlns.scr.v1._2.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.BasicFeatureMap;
import org.eclipse.emf.ecore.util.FeatureMap;
import org.eclipse.emf.ecore.util.InternalEList;

import org.osgi.xmlns.scr.v1._2.Tcardinality;
import org.osgi.xmlns.scr.v1._2.Tpolicy;
import org.osgi.xmlns.scr.v1._2.TpolicyOption;
import org.osgi.xmlns.scr.v1._2.Treference;
import org.osgi.xmlns.scr.v1._2.scrPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Treference</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getAny <em>Any</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getBind <em>Bind</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getCardinality <em>Cardinality</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getInterface <em>Interface</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getPolicy <em>Policy</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getPolicyOption <em>Policy Option</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getTarget <em>Target</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getUnbind <em>Unbind</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getUpdated <em>Updated</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TreferenceImpl#getAnyAttribute <em>Any Attribute</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TreferenceImpl extends EObjectImpl implements Treference {
	/**
	 * The cached value of the '{@link #getAny() <em>Any</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAny()
	 * @generated
	 * @ordered
	 */
	protected FeatureMap any;

	/**
	 * The default value of the '{@link #getBind() <em>Bind</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBind()
	 * @generated
	 * @ordered
	 */
	protected static final String BIND_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getBind() <em>Bind</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBind()
	 * @generated
	 * @ordered
	 */
	protected String bind = BIND_EDEFAULT;

	/**
	 * The default value of the '{@link #getCardinality() <em>Cardinality</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCardinality()
	 * @generated
	 * @ordered
	 */
	protected static final Tcardinality CARDINALITY_EDEFAULT = Tcardinality._11_LITERAL;

	/**
	 * The cached value of the '{@link #getCardinality() <em>Cardinality</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCardinality()
	 * @generated
	 * @ordered
	 */
	protected Tcardinality cardinality = CARDINALITY_EDEFAULT;

	/**
	 * This is true if the Cardinality attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean cardinalityESet;

	/**
	 * The default value of the '{@link #getInterface() <em>Interface</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterface()
	 * @generated
	 * @ordered
	 */
	protected static final String INTERFACE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getInterface() <em>Interface</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterface()
	 * @generated
	 * @ordered
	 */
	protected String interface_ = INTERFACE_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getPolicy() <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicy()
	 * @generated
	 * @ordered
	 */
	protected static final Tpolicy POLICY_EDEFAULT = Tpolicy.STATIC_LITERAL;

	/**
	 * The cached value of the '{@link #getPolicy() <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicy()
	 * @generated
	 * @ordered
	 */
	protected Tpolicy policy = POLICY_EDEFAULT;

	/**
	 * This is true if the Policy attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean policyESet;

	/**
	 * The default value of the '{@link #getPolicyOption() <em>Policy Option</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicyOption()
	 * @generated
	 * @ordered
	 */
	protected static final TpolicyOption POLICY_OPTION_EDEFAULT = TpolicyOption.RELUCTANT_LITERAL;

	/**
	 * The cached value of the '{@link #getPolicyOption() <em>Policy Option</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicyOption()
	 * @generated
	 * @ordered
	 */
	protected TpolicyOption policyOption = POLICY_OPTION_EDEFAULT;

	/**
	 * This is true if the Policy Option attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean policyOptionESet;

	/**
	 * The default value of the '{@link #getTarget() <em>Target</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTarget()
	 * @generated
	 * @ordered
	 */
	protected static final String TARGET_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTarget() <em>Target</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTarget()
	 * @generated
	 * @ordered
	 */
	protected String target = TARGET_EDEFAULT;

	/**
	 * The default value of the '{@link #getUnbind() <em>Unbind</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnbind()
	 * @generated
	 * @ordered
	 */
	protected static final String UNBIND_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUnbind() <em>Unbind</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnbind()
	 * @generated
	 * @ordered
	 */
	protected String unbind = UNBIND_EDEFAULT;

	/**
	 * The default value of the '{@link #getUpdated() <em>Updated</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUpdated()
	 * @generated
	 * @ordered
	 */
	protected static final String UPDATED_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUpdated() <em>Updated</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUpdated()
	 * @generated
	 * @ordered
	 */
	protected String updated = UPDATED_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAnyAttribute() <em>Any Attribute</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAnyAttribute()
	 * @generated
	 * @ordered
	 */
	protected FeatureMap anyAttribute;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TreferenceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return scrPackage.Literals.TREFERENCE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureMap getAny() {
		if (any == null) {
			any = new BasicFeatureMap(this, scrPackage.TREFERENCE__ANY);
		}
		return any;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getBind() {
		return bind;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBind(String newBind) {
		String oldBind = bind;
		bind = newBind;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TREFERENCE__BIND, oldBind, bind));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Tcardinality getCardinality() {
		return cardinality;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCardinality(Tcardinality newCardinality) {
		Tcardinality oldCardinality = cardinality;
		cardinality = newCardinality == null ? CARDINALITY_EDEFAULT : newCardinality;
		boolean oldCardinalityESet = cardinalityESet;
		cardinalityESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TREFERENCE__CARDINALITY, oldCardinality, cardinality, !oldCardinalityESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetCardinality() {
		Tcardinality oldCardinality = cardinality;
		boolean oldCardinalityESet = cardinalityESet;
		cardinality = CARDINALITY_EDEFAULT;
		cardinalityESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, scrPackage.TREFERENCE__CARDINALITY, oldCardinality, CARDINALITY_EDEFAULT, oldCardinalityESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetCardinality() {
		return cardinalityESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getInterface() {
		return interface_;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInterface(String newInterface) {
		String oldInterface = interface_;
		interface_ = newInterface;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TREFERENCE__INTERFACE, oldInterface, interface_));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TREFERENCE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Tpolicy getPolicy() {
		return policy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPolicy(Tpolicy newPolicy) {
		Tpolicy oldPolicy = policy;
		policy = newPolicy == null ? POLICY_EDEFAULT : newPolicy;
		boolean oldPolicyESet = policyESet;
		policyESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TREFERENCE__POLICY, oldPolicy, policy, !oldPolicyESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetPolicy() {
		Tpolicy oldPolicy = policy;
		boolean oldPolicyESet = policyESet;
		policy = POLICY_EDEFAULT;
		policyESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, scrPackage.TREFERENCE__POLICY, oldPolicy, POLICY_EDEFAULT, oldPolicyESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetPolicy() {
		return policyESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TpolicyOption getPolicyOption() {
		return policyOption;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPolicyOption(TpolicyOption newPolicyOption) {
		TpolicyOption oldPolicyOption = policyOption;
		policyOption = newPolicyOption == null ? POLICY_OPTION_EDEFAULT : newPolicyOption;
		boolean oldPolicyOptionESet = policyOptionESet;
		policyOptionESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TREFERENCE__POLICY_OPTION, oldPolicyOption, policyOption, !oldPolicyOptionESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetPolicyOption() {
		TpolicyOption oldPolicyOption = policyOption;
		boolean oldPolicyOptionESet = policyOptionESet;
		policyOption = POLICY_OPTION_EDEFAULT;
		policyOptionESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, scrPackage.TREFERENCE__POLICY_OPTION, oldPolicyOption, POLICY_OPTION_EDEFAULT, oldPolicyOptionESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetPolicyOption() {
		return policyOptionESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getTarget() {
		return target;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTarget(String newTarget) {
		String oldTarget = target;
		target = newTarget;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TREFERENCE__TARGET, oldTarget, target));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUnbind() {
		return unbind;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnbind(String newUnbind) {
		String oldUnbind = unbind;
		unbind = newUnbind;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TREFERENCE__UNBIND, oldUnbind, unbind));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUpdated() {
		return updated;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUpdated(String newUpdated) {
		String oldUpdated = updated;
		updated = newUpdated;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TREFERENCE__UPDATED, oldUpdated, updated));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureMap getAnyAttribute() {
		if (anyAttribute == null) {
			anyAttribute = new BasicFeatureMap(this, scrPackage.TREFERENCE__ANY_ATTRIBUTE);
		}
		return anyAttribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case scrPackage.TREFERENCE__ANY:
				return ((InternalEList)getAny()).basicRemove(otherEnd, msgs);
			case scrPackage.TREFERENCE__ANY_ATTRIBUTE:
				return ((InternalEList)getAnyAttribute()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case scrPackage.TREFERENCE__ANY:
				if (coreType) return getAny();
				return ((FeatureMap.Internal)getAny()).getWrapper();
			case scrPackage.TREFERENCE__BIND:
				return getBind();
			case scrPackage.TREFERENCE__CARDINALITY:
				return getCardinality();
			case scrPackage.TREFERENCE__INTERFACE:
				return getInterface();
			case scrPackage.TREFERENCE__NAME:
				return getName();
			case scrPackage.TREFERENCE__POLICY:
				return getPolicy();
			case scrPackage.TREFERENCE__POLICY_OPTION:
				return getPolicyOption();
			case scrPackage.TREFERENCE__TARGET:
				return getTarget();
			case scrPackage.TREFERENCE__UNBIND:
				return getUnbind();
			case scrPackage.TREFERENCE__UPDATED:
				return getUpdated();
			case scrPackage.TREFERENCE__ANY_ATTRIBUTE:
				if (coreType) return getAnyAttribute();
				return ((FeatureMap.Internal)getAnyAttribute()).getWrapper();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case scrPackage.TREFERENCE__ANY:
				((FeatureMap.Internal)getAny()).set(newValue);
				return;
			case scrPackage.TREFERENCE__BIND:
				setBind((String)newValue);
				return;
			case scrPackage.TREFERENCE__CARDINALITY:
				setCardinality((Tcardinality)newValue);
				return;
			case scrPackage.TREFERENCE__INTERFACE:
				setInterface((String)newValue);
				return;
			case scrPackage.TREFERENCE__NAME:
				setName((String)newValue);
				return;
			case scrPackage.TREFERENCE__POLICY:
				setPolicy((Tpolicy)newValue);
				return;
			case scrPackage.TREFERENCE__POLICY_OPTION:
				setPolicyOption((TpolicyOption)newValue);
				return;
			case scrPackage.TREFERENCE__TARGET:
				setTarget((String)newValue);
				return;
			case scrPackage.TREFERENCE__UNBIND:
				setUnbind((String)newValue);
				return;
			case scrPackage.TREFERENCE__UPDATED:
				setUpdated((String)newValue);
				return;
			case scrPackage.TREFERENCE__ANY_ATTRIBUTE:
				((FeatureMap.Internal)getAnyAttribute()).set(newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case scrPackage.TREFERENCE__ANY:
				getAny().clear();
				return;
			case scrPackage.TREFERENCE__BIND:
				setBind(BIND_EDEFAULT);
				return;
			case scrPackage.TREFERENCE__CARDINALITY:
				unsetCardinality();
				return;
			case scrPackage.TREFERENCE__INTERFACE:
				setInterface(INTERFACE_EDEFAULT);
				return;
			case scrPackage.TREFERENCE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case scrPackage.TREFERENCE__POLICY:
				unsetPolicy();
				return;
			case scrPackage.TREFERENCE__POLICY_OPTION:
				unsetPolicyOption();
				return;
			case scrPackage.TREFERENCE__TARGET:
				setTarget(TARGET_EDEFAULT);
				return;
			case scrPackage.TREFERENCE__UNBIND:
				setUnbind(UNBIND_EDEFAULT);
				return;
			case scrPackage.TREFERENCE__UPDATED:
				setUpdated(UPDATED_EDEFAULT);
				return;
			case scrPackage.TREFERENCE__ANY_ATTRIBUTE:
				getAnyAttribute().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case scrPackage.TREFERENCE__ANY:
				return any != null && !any.isEmpty();
			case scrPackage.TREFERENCE__BIND:
				return BIND_EDEFAULT == null ? bind != null : !BIND_EDEFAULT.equals(bind);
			case scrPackage.TREFERENCE__CARDINALITY:
				return isSetCardinality();
			case scrPackage.TREFERENCE__INTERFACE:
				return INTERFACE_EDEFAULT == null ? interface_ != null : !INTERFACE_EDEFAULT.equals(interface_);
			case scrPackage.TREFERENCE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case scrPackage.TREFERENCE__POLICY:
				return isSetPolicy();
			case scrPackage.TREFERENCE__POLICY_OPTION:
				return isSetPolicyOption();
			case scrPackage.TREFERENCE__TARGET:
				return TARGET_EDEFAULT == null ? target != null : !TARGET_EDEFAULT.equals(target);
			case scrPackage.TREFERENCE__UNBIND:
				return UNBIND_EDEFAULT == null ? unbind != null : !UNBIND_EDEFAULT.equals(unbind);
			case scrPackage.TREFERENCE__UPDATED:
				return UPDATED_EDEFAULT == null ? updated != null : !UPDATED_EDEFAULT.equals(updated);
			case scrPackage.TREFERENCE__ANY_ATTRIBUTE:
				return anyAttribute != null && !anyAttribute.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (any: ");
		result.append(any);
		result.append(", bind: ");
		result.append(bind);
		result.append(", cardinality: ");
		if (cardinalityESet) result.append(cardinality); else result.append("<unset>");
		result.append(", interface: ");
		result.append(interface_);
		result.append(", name: ");
		result.append(name);
		result.append(", policy: ");
		if (policyESet) result.append(policy); else result.append("<unset>");
		result.append(", policyOption: ");
		if (policyOptionESet) result.append(policyOption); else result.append("<unset>");
		result.append(", target: ");
		result.append(target);
		result.append(", unbind: ");
		result.append(unbind);
		result.append(", updated: ");
		result.append(updated);
		result.append(", anyAttribute: ");
		result.append(anyAttribute);
		result.append(')');
		return result.toString();
	}

} //TreferenceImpl
