package org.cinco.mdplugin.seam;

import java.awt.event.ActionEvent;

import com.nomagic.magicdraw.actions.ActionsConfiguratorsManager;
import com.nomagic.magicdraw.core.Application;
import com.nomagic.magicdraw.plugins.Plugin;
import com.nomagic.actions.ActionsCategory;
import com.nomagic.actions.NMAction;

public class SEAMPlugin extends Plugin {

	@Override
	public boolean close() {
		return true;
	}

	@Override
	public void init() {
		ActionsConfiguratorsManager manager = ActionsConfiguratorsManager
				.getInstance();
		manager.addMainMenuConfigurator(new MainMenuConfigurator(
				getProjectsActions()));
	}

	@SuppressWarnings("serial")
	private NMAction getProjectsActions() {
		ActionsCategory category = new ActionsCategory(null, "SEAM");
		// this call makes submenu.
		category.setNested(true);

		/*
		 * Add new action to the category.
		 */
		category.addAction(new NMAction("About SEAM plugin", "About SEAM plugin", null,
				null) {
			@Override
			public void actionPerformed(ActionEvent e) {
				javax.swing.JOptionPane.showMessageDialog(null, 
						"About SEAM plugin\n" +
						"Author: Toni Ruokolainen (2012)\n" +
						"Version: 1.0.0\n\n" +
						"Currently only utilized for distributing SEAM resources (profiles, diagrams and templates)."
				);
			}
		});
		return category;
	}

	@Override
	public boolean isSupported() {

		return true;
	}

}
