/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl;

import java.util.Collection;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.features.Rule;

import org.cinco.metamodel.ecosystem.ecosystemintensionmodel.impl.StructuralElementImpl;

import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.BusinessAction;
import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.BusinessTransaction;
import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.ChoreographiesPackage;
import org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.ServiceCommitment;

import org.cinco.metamodel.ecosystem.foundations.behaviour.Action;
import org.cinco.metamodel.ecosystem.foundations.behaviour.Behaviour;
import org.cinco.metamodel.ecosystem.foundations.behaviour.BehaviourPackage;
import org.cinco.metamodel.ecosystem.foundations.behaviour.ChoreographyStage;
import org.cinco.metamodel.ecosystem.foundations.behaviour.Event;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Business Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.BusinessActionImpl#getPredecessor <em>Predecessor</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.BusinessActionImpl#getBehaviour <em>Behaviour</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.BusinessActionImpl#getRec <em>Rec</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.BusinessActionImpl#getCondition <em>Condition</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.BusinessActionImpl#getTransaction <em>Transaction</em>}</li>
 *   <li>{@link org.cinco.metamodel.ecosystem.ecosystemmodel.choreographies.impl.BusinessActionImpl#getCommitment <em>Commitment</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BusinessActionImpl extends StructuralElementImpl implements BusinessAction {
	/**
	 * The cached value of the '{@link #getPredecessor() <em>Predecessor</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPredecessor()
	 * @generated
	 * @ordered
	 */
	protected EList predecessor;

	/**
	 * The cached value of the '{@link #getBehaviour() <em>Behaviour</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBehaviour()
	 * @generated
	 * @ordered
	 */
	protected Behaviour behaviour;

	/**
	 * The cached value of the '{@link #getRec() <em>Rec</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRec()
	 * @generated
	 * @ordered
	 */
	protected Action rec;

	/**
	 * The cached value of the '{@link #getCondition() <em>Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCondition()
	 * @generated
	 * @ordered
	 */
	protected Rule condition;

	/**
	 * The cached value of the '{@link #getTransaction() <em>Transaction</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTransaction()
	 * @generated
	 * @ordered
	 */
	protected EList transaction;

	/**
	 * The cached value of the '{@link #getCommitment() <em>Commitment</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCommitment()
	 * @generated
	 * @ordered
	 */
	protected ServiceCommitment commitment;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BusinessActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ChoreographiesPackage.Literals.BUSINESS_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getPredecessor() {
		if (predecessor == null) {
			predecessor = new EObjectResolvingEList(Event.class, this, ChoreographiesPackage.BUSINESS_ACTION__PREDECESSOR);
		}
		return predecessor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Behaviour getBehaviour() {
		if (behaviour != null && behaviour.eIsProxy()) {
			InternalEObject oldBehaviour = (InternalEObject)behaviour;
			behaviour = (Behaviour)eResolveProxy(oldBehaviour);
			if (behaviour != oldBehaviour) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ChoreographiesPackage.BUSINESS_ACTION__BEHAVIOUR, oldBehaviour, behaviour));
			}
		}
		return behaviour;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Behaviour basicGetBehaviour() {
		return behaviour;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBehaviour(Behaviour newBehaviour) {
		Behaviour oldBehaviour = behaviour;
		behaviour = newBehaviour;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ChoreographiesPackage.BUSINESS_ACTION__BEHAVIOUR, oldBehaviour, behaviour));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Action getRec() {
		if (rec != null && rec.eIsProxy()) {
			InternalEObject oldRec = (InternalEObject)rec;
			rec = (Action)eResolveProxy(oldRec);
			if (rec != oldRec) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ChoreographiesPackage.BUSINESS_ACTION__REC, oldRec, rec));
			}
		}
		return rec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Action basicGetRec() {
		return rec;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRec(Action newRec) {
		Action oldRec = rec;
		rec = newRec;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ChoreographiesPackage.BUSINESS_ACTION__REC, oldRec, rec));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Rule getCondition() {
		return condition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCondition(Rule newCondition, NotificationChain msgs) {
		Rule oldCondition = condition;
		condition = newCondition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ChoreographiesPackage.BUSINESS_ACTION__CONDITION, oldCondition, newCondition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCondition(Rule newCondition) {
		if (newCondition != condition) {
			NotificationChain msgs = null;
			if (condition != null)
				msgs = ((InternalEObject)condition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ChoreographiesPackage.BUSINESS_ACTION__CONDITION, null, msgs);
			if (newCondition != null)
				msgs = ((InternalEObject)newCondition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ChoreographiesPackage.BUSINESS_ACTION__CONDITION, null, msgs);
			msgs = basicSetCondition(newCondition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ChoreographiesPackage.BUSINESS_ACTION__CONDITION, newCondition, newCondition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getTransaction() {
		if (transaction == null) {
			transaction = new EObjectWithInverseResolvingEList.ManyInverse(BusinessTransaction.class, this, ChoreographiesPackage.BUSINESS_ACTION__TRANSACTION, ChoreographiesPackage.BUSINESS_TRANSACTION__ACTION);
		}
		return transaction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServiceCommitment getCommitment() {
		if (commitment != null && commitment.eIsProxy()) {
			InternalEObject oldCommitment = (InternalEObject)commitment;
			commitment = (ServiceCommitment)eResolveProxy(oldCommitment);
			if (commitment != oldCommitment) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ChoreographiesPackage.BUSINESS_ACTION__COMMITMENT, oldCommitment, commitment));
			}
		}
		return commitment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServiceCommitment basicGetCommitment() {
		return commitment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCommitment(ServiceCommitment newCommitment) {
		ServiceCommitment oldCommitment = commitment;
		commitment = newCommitment;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ChoreographiesPackage.BUSINESS_ACTION__COMMITMENT, oldCommitment, commitment));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ChoreographiesPackage.BUSINESS_ACTION__TRANSACTION:
				return ((InternalEList)getTransaction()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ChoreographiesPackage.BUSINESS_ACTION__CONDITION:
				return basicSetCondition(null, msgs);
			case ChoreographiesPackage.BUSINESS_ACTION__TRANSACTION:
				return ((InternalEList)getTransaction()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ChoreographiesPackage.BUSINESS_ACTION__PREDECESSOR:
				return getPredecessor();
			case ChoreographiesPackage.BUSINESS_ACTION__BEHAVIOUR:
				if (resolve) return getBehaviour();
				return basicGetBehaviour();
			case ChoreographiesPackage.BUSINESS_ACTION__REC:
				if (resolve) return getRec();
				return basicGetRec();
			case ChoreographiesPackage.BUSINESS_ACTION__CONDITION:
				return getCondition();
			case ChoreographiesPackage.BUSINESS_ACTION__TRANSACTION:
				return getTransaction();
			case ChoreographiesPackage.BUSINESS_ACTION__COMMITMENT:
				if (resolve) return getCommitment();
				return basicGetCommitment();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ChoreographiesPackage.BUSINESS_ACTION__PREDECESSOR:
				getPredecessor().clear();
				getPredecessor().addAll((Collection)newValue);
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__BEHAVIOUR:
				setBehaviour((Behaviour)newValue);
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__REC:
				setRec((Action)newValue);
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__CONDITION:
				setCondition((Rule)newValue);
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__TRANSACTION:
				getTransaction().clear();
				getTransaction().addAll((Collection)newValue);
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__COMMITMENT:
				setCommitment((ServiceCommitment)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case ChoreographiesPackage.BUSINESS_ACTION__PREDECESSOR:
				getPredecessor().clear();
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__BEHAVIOUR:
				setBehaviour((Behaviour)null);
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__REC:
				setRec((Action)null);
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__CONDITION:
				setCondition((Rule)null);
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__TRANSACTION:
				getTransaction().clear();
				return;
			case ChoreographiesPackage.BUSINESS_ACTION__COMMITMENT:
				setCommitment((ServiceCommitment)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ChoreographiesPackage.BUSINESS_ACTION__PREDECESSOR:
				return predecessor != null && !predecessor.isEmpty();
			case ChoreographiesPackage.BUSINESS_ACTION__BEHAVIOUR:
				return behaviour != null;
			case ChoreographiesPackage.BUSINESS_ACTION__REC:
				return rec != null;
			case ChoreographiesPackage.BUSINESS_ACTION__CONDITION:
				return condition != null;
			case ChoreographiesPackage.BUSINESS_ACTION__TRANSACTION:
				return transaction != null && !transaction.isEmpty();
			case ChoreographiesPackage.BUSINESS_ACTION__COMMITMENT:
				return commitment != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
		if (baseClass == Event.class) {
			switch (derivedFeatureID) {
				case ChoreographiesPackage.BUSINESS_ACTION__PREDECESSOR: return BehaviourPackage.EVENT__PREDECESSOR;
				case ChoreographiesPackage.BUSINESS_ACTION__BEHAVIOUR: return BehaviourPackage.EVENT__BEHAVIOUR;
				default: return -1;
			}
		}
		if (baseClass == Action.class) {
			switch (derivedFeatureID) {
				case ChoreographiesPackage.BUSINESS_ACTION__REC: return BehaviourPackage.ACTION__REC;
				default: return -1;
			}
		}
		if (baseClass == ChoreographyStage.class) {
			switch (derivedFeatureID) {
				case ChoreographiesPackage.BUSINESS_ACTION__CONDITION: return BehaviourPackage.CHOREOGRAPHY_STAGE__CONDITION;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
		if (baseClass == Event.class) {
			switch (baseFeatureID) {
				case BehaviourPackage.EVENT__PREDECESSOR: return ChoreographiesPackage.BUSINESS_ACTION__PREDECESSOR;
				case BehaviourPackage.EVENT__BEHAVIOUR: return ChoreographiesPackage.BUSINESS_ACTION__BEHAVIOUR;
				default: return -1;
			}
		}
		if (baseClass == Action.class) {
			switch (baseFeatureID) {
				case BehaviourPackage.ACTION__REC: return ChoreographiesPackage.BUSINESS_ACTION__REC;
				default: return -1;
			}
		}
		if (baseClass == ChoreographyStage.class) {
			switch (baseFeatureID) {
				case BehaviourPackage.CHOREOGRAPHY_STAGE__CONDITION: return ChoreographiesPackage.BUSINESS_ACTION__CONDITION;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} //BusinessActionImpl
