/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.osgi.xmlns.scr.v1._2.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.BasicFeatureMap;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.FeatureMap;
import org.eclipse.emf.ecore.util.InternalEList;

import org.osgi.xmlns.scr.v1._2.Tcomponent;
import org.osgi.xmlns.scr.v1._2.TconfigurationPolicy;
import org.osgi.xmlns.scr.v1._2.Timplementation;
import org.osgi.xmlns.scr.v1._2.Treference;
import org.osgi.xmlns.scr.v1._2.Tservice;
import org.osgi.xmlns.scr.v1._2.scrPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Tcomponent</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getGroup <em>Group</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getProperty <em>Property</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getProperties <em>Properties</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getService <em>Service</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getReference <em>Reference</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getImplementation <em>Implementation</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getAny <em>Any</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getActivate <em>Activate</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getConfigurationPid <em>Configuration Pid</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getConfigurationPolicy <em>Configuration Policy</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getDeactivate <em>Deactivate</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#isEnabled <em>Enabled</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getFactory <em>Factory</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#isImmediate <em>Immediate</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getModified <em>Modified</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.osgi.xmlns.scr.v1._2.impl.TcomponentImpl#getAnyAttribute <em>Any Attribute</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TcomponentImpl extends EObjectImpl implements Tcomponent {
	/**
	 * The cached value of the '{@link #getGroup() <em>Group</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGroup()
	 * @generated
	 * @ordered
	 */
	protected FeatureMap group;

	/**
	 * The cached value of the '{@link #getService() <em>Service</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getService()
	 * @generated
	 * @ordered
	 */
	protected Tservice service;

	/**
	 * The cached value of the '{@link #getReference() <em>Reference</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReference()
	 * @generated
	 * @ordered
	 */
	protected EList reference;

	/**
	 * The cached value of the '{@link #getImplementation() <em>Implementation</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getImplementation()
	 * @generated
	 * @ordered
	 */
	protected Timplementation implementation;

	/**
	 * The cached value of the '{@link #getAny() <em>Any</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAny()
	 * @generated
	 * @ordered
	 */
	protected FeatureMap any;

	/**
	 * The default value of the '{@link #getActivate() <em>Activate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActivate()
	 * @generated
	 * @ordered
	 */
	protected static final String ACTIVATE_EDEFAULT = "activate";

	/**
	 * The cached value of the '{@link #getActivate() <em>Activate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActivate()
	 * @generated
	 * @ordered
	 */
	protected String activate = ACTIVATE_EDEFAULT;

	/**
	 * This is true if the Activate attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean activateESet;

	/**
	 * The default value of the '{@link #getConfigurationPid() <em>Configuration Pid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConfigurationPid()
	 * @generated
	 * @ordered
	 */
	protected static final String CONFIGURATION_PID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getConfigurationPid() <em>Configuration Pid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConfigurationPid()
	 * @generated
	 * @ordered
	 */
	protected String configurationPid = CONFIGURATION_PID_EDEFAULT;

	/**
	 * The default value of the '{@link #getConfigurationPolicy() <em>Configuration Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConfigurationPolicy()
	 * @generated
	 * @ordered
	 */
	protected static final TconfigurationPolicy CONFIGURATION_POLICY_EDEFAULT = TconfigurationPolicy.OPTIONAL_LITERAL;

	/**
	 * The cached value of the '{@link #getConfigurationPolicy() <em>Configuration Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConfigurationPolicy()
	 * @generated
	 * @ordered
	 */
	protected TconfigurationPolicy configurationPolicy = CONFIGURATION_POLICY_EDEFAULT;

	/**
	 * This is true if the Configuration Policy attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean configurationPolicyESet;

	/**
	 * The default value of the '{@link #getDeactivate() <em>Deactivate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeactivate()
	 * @generated
	 * @ordered
	 */
	protected static final String DEACTIVATE_EDEFAULT = "deactivate";

	/**
	 * The cached value of the '{@link #getDeactivate() <em>Deactivate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeactivate()
	 * @generated
	 * @ordered
	 */
	protected String deactivate = DEACTIVATE_EDEFAULT;

	/**
	 * This is true if the Deactivate attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean deactivateESet;

	/**
	 * The default value of the '{@link #isEnabled() <em>Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEnabled()
	 * @generated
	 * @ordered
	 */
	protected static final boolean ENABLED_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isEnabled() <em>Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEnabled()
	 * @generated
	 * @ordered
	 */
	protected boolean enabled = ENABLED_EDEFAULT;

	/**
	 * This is true if the Enabled attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean enabledESet;

	/**
	 * The default value of the '{@link #getFactory() <em>Factory</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactory()
	 * @generated
	 * @ordered
	 */
	protected static final String FACTORY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getFactory() <em>Factory</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactory()
	 * @generated
	 * @ordered
	 */
	protected String factory = FACTORY_EDEFAULT;

	/**
	 * The default value of the '{@link #isImmediate() <em>Immediate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isImmediate()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IMMEDIATE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isImmediate() <em>Immediate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isImmediate()
	 * @generated
	 * @ordered
	 */
	protected boolean immediate = IMMEDIATE_EDEFAULT;

	/**
	 * This is true if the Immediate attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean immediateESet;

	/**
	 * The default value of the '{@link #getModified() <em>Modified</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModified()
	 * @generated
	 * @ordered
	 */
	protected static final String MODIFIED_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getModified() <em>Modified</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModified()
	 * @generated
	 * @ordered
	 */
	protected String modified = MODIFIED_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAnyAttribute() <em>Any Attribute</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAnyAttribute()
	 * @generated
	 * @ordered
	 */
	protected FeatureMap anyAttribute;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TcomponentImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return scrPackage.Literals.TCOMPONENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureMap getGroup() {
		if (group == null) {
			group = new BasicFeatureMap(this, scrPackage.TCOMPONENT__GROUP);
		}
		return group;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getProperty() {
		return getGroup().list(scrPackage.Literals.TCOMPONENT__PROPERTY);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getProperties() {
		return getGroup().list(scrPackage.Literals.TCOMPONENT__PROPERTIES);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Tservice getService() {
		return service;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetService(Tservice newService, NotificationChain msgs) {
		Tservice oldService = service;
		service = newService;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__SERVICE, oldService, newService);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setService(Tservice newService) {
		if (newService != service) {
			NotificationChain msgs = null;
			if (service != null)
				msgs = ((InternalEObject)service).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - scrPackage.TCOMPONENT__SERVICE, null, msgs);
			if (newService != null)
				msgs = ((InternalEObject)newService).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - scrPackage.TCOMPONENT__SERVICE, null, msgs);
			msgs = basicSetService(newService, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__SERVICE, newService, newService));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getReference() {
		if (reference == null) {
			reference = new EObjectContainmentEList(Treference.class, this, scrPackage.TCOMPONENT__REFERENCE);
		}
		return reference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Timplementation getImplementation() {
		return implementation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetImplementation(Timplementation newImplementation, NotificationChain msgs) {
		Timplementation oldImplementation = implementation;
		implementation = newImplementation;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__IMPLEMENTATION, oldImplementation, newImplementation);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setImplementation(Timplementation newImplementation) {
		if (newImplementation != implementation) {
			NotificationChain msgs = null;
			if (implementation != null)
				msgs = ((InternalEObject)implementation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - scrPackage.TCOMPONENT__IMPLEMENTATION, null, msgs);
			if (newImplementation != null)
				msgs = ((InternalEObject)newImplementation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - scrPackage.TCOMPONENT__IMPLEMENTATION, null, msgs);
			msgs = basicSetImplementation(newImplementation, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__IMPLEMENTATION, newImplementation, newImplementation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureMap getAny() {
		if (any == null) {
			any = new BasicFeatureMap(this, scrPackage.TCOMPONENT__ANY);
		}
		return any;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getActivate() {
		return activate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setActivate(String newActivate) {
		String oldActivate = activate;
		activate = newActivate;
		boolean oldActivateESet = activateESet;
		activateESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__ACTIVATE, oldActivate, activate, !oldActivateESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetActivate() {
		String oldActivate = activate;
		boolean oldActivateESet = activateESet;
		activate = ACTIVATE_EDEFAULT;
		activateESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, scrPackage.TCOMPONENT__ACTIVATE, oldActivate, ACTIVATE_EDEFAULT, oldActivateESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetActivate() {
		return activateESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getConfigurationPid() {
		return configurationPid;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setConfigurationPid(String newConfigurationPid) {
		String oldConfigurationPid = configurationPid;
		configurationPid = newConfigurationPid;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__CONFIGURATION_PID, oldConfigurationPid, configurationPid));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TconfigurationPolicy getConfigurationPolicy() {
		return configurationPolicy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setConfigurationPolicy(TconfigurationPolicy newConfigurationPolicy) {
		TconfigurationPolicy oldConfigurationPolicy = configurationPolicy;
		configurationPolicy = newConfigurationPolicy == null ? CONFIGURATION_POLICY_EDEFAULT : newConfigurationPolicy;
		boolean oldConfigurationPolicyESet = configurationPolicyESet;
		configurationPolicyESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__CONFIGURATION_POLICY, oldConfigurationPolicy, configurationPolicy, !oldConfigurationPolicyESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetConfigurationPolicy() {
		TconfigurationPolicy oldConfigurationPolicy = configurationPolicy;
		boolean oldConfigurationPolicyESet = configurationPolicyESet;
		configurationPolicy = CONFIGURATION_POLICY_EDEFAULT;
		configurationPolicyESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, scrPackage.TCOMPONENT__CONFIGURATION_POLICY, oldConfigurationPolicy, CONFIGURATION_POLICY_EDEFAULT, oldConfigurationPolicyESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetConfigurationPolicy() {
		return configurationPolicyESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDeactivate() {
		return deactivate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeactivate(String newDeactivate) {
		String oldDeactivate = deactivate;
		deactivate = newDeactivate;
		boolean oldDeactivateESet = deactivateESet;
		deactivateESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__DEACTIVATE, oldDeactivate, deactivate, !oldDeactivateESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetDeactivate() {
		String oldDeactivate = deactivate;
		boolean oldDeactivateESet = deactivateESet;
		deactivate = DEACTIVATE_EDEFAULT;
		deactivateESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, scrPackage.TCOMPONENT__DEACTIVATE, oldDeactivate, DEACTIVATE_EDEFAULT, oldDeactivateESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetDeactivate() {
		return deactivateESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isEnabled() {
		return enabled;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEnabled(boolean newEnabled) {
		boolean oldEnabled = enabled;
		enabled = newEnabled;
		boolean oldEnabledESet = enabledESet;
		enabledESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__ENABLED, oldEnabled, enabled, !oldEnabledESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetEnabled() {
		boolean oldEnabled = enabled;
		boolean oldEnabledESet = enabledESet;
		enabled = ENABLED_EDEFAULT;
		enabledESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, scrPackage.TCOMPONENT__ENABLED, oldEnabled, ENABLED_EDEFAULT, oldEnabledESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetEnabled() {
		return enabledESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getFactory() {
		return factory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFactory(String newFactory) {
		String oldFactory = factory;
		factory = newFactory;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__FACTORY, oldFactory, factory));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isImmediate() {
		return immediate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setImmediate(boolean newImmediate) {
		boolean oldImmediate = immediate;
		immediate = newImmediate;
		boolean oldImmediateESet = immediateESet;
		immediateESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__IMMEDIATE, oldImmediate, immediate, !oldImmediateESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetImmediate() {
		boolean oldImmediate = immediate;
		boolean oldImmediateESet = immediateESet;
		immediate = IMMEDIATE_EDEFAULT;
		immediateESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, scrPackage.TCOMPONENT__IMMEDIATE, oldImmediate, IMMEDIATE_EDEFAULT, oldImmediateESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetImmediate() {
		return immediateESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getModified() {
		return modified;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setModified(String newModified) {
		String oldModified = modified;
		modified = newModified;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__MODIFIED, oldModified, modified));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, scrPackage.TCOMPONENT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureMap getAnyAttribute() {
		if (anyAttribute == null) {
			anyAttribute = new BasicFeatureMap(this, scrPackage.TCOMPONENT__ANY_ATTRIBUTE);
		}
		return anyAttribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case scrPackage.TCOMPONENT__GROUP:
				return ((InternalEList)getGroup()).basicRemove(otherEnd, msgs);
			case scrPackage.TCOMPONENT__PROPERTY:
				return ((InternalEList)getProperty()).basicRemove(otherEnd, msgs);
			case scrPackage.TCOMPONENT__PROPERTIES:
				return ((InternalEList)getProperties()).basicRemove(otherEnd, msgs);
			case scrPackage.TCOMPONENT__SERVICE:
				return basicSetService(null, msgs);
			case scrPackage.TCOMPONENT__REFERENCE:
				return ((InternalEList)getReference()).basicRemove(otherEnd, msgs);
			case scrPackage.TCOMPONENT__IMPLEMENTATION:
				return basicSetImplementation(null, msgs);
			case scrPackage.TCOMPONENT__ANY:
				return ((InternalEList)getAny()).basicRemove(otherEnd, msgs);
			case scrPackage.TCOMPONENT__ANY_ATTRIBUTE:
				return ((InternalEList)getAnyAttribute()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case scrPackage.TCOMPONENT__GROUP:
				if (coreType) return getGroup();
				return ((FeatureMap.Internal)getGroup()).getWrapper();
			case scrPackage.TCOMPONENT__PROPERTY:
				return getProperty();
			case scrPackage.TCOMPONENT__PROPERTIES:
				return getProperties();
			case scrPackage.TCOMPONENT__SERVICE:
				return getService();
			case scrPackage.TCOMPONENT__REFERENCE:
				return getReference();
			case scrPackage.TCOMPONENT__IMPLEMENTATION:
				return getImplementation();
			case scrPackage.TCOMPONENT__ANY:
				if (coreType) return getAny();
				return ((FeatureMap.Internal)getAny()).getWrapper();
			case scrPackage.TCOMPONENT__ACTIVATE:
				return getActivate();
			case scrPackage.TCOMPONENT__CONFIGURATION_PID:
				return getConfigurationPid();
			case scrPackage.TCOMPONENT__CONFIGURATION_POLICY:
				return getConfigurationPolicy();
			case scrPackage.TCOMPONENT__DEACTIVATE:
				return getDeactivate();
			case scrPackage.TCOMPONENT__ENABLED:
				return isEnabled() ? Boolean.TRUE : Boolean.FALSE;
			case scrPackage.TCOMPONENT__FACTORY:
				return getFactory();
			case scrPackage.TCOMPONENT__IMMEDIATE:
				return isImmediate() ? Boolean.TRUE : Boolean.FALSE;
			case scrPackage.TCOMPONENT__MODIFIED:
				return getModified();
			case scrPackage.TCOMPONENT__NAME:
				return getName();
			case scrPackage.TCOMPONENT__ANY_ATTRIBUTE:
				if (coreType) return getAnyAttribute();
				return ((FeatureMap.Internal)getAnyAttribute()).getWrapper();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case scrPackage.TCOMPONENT__GROUP:
				((FeatureMap.Internal)getGroup()).set(newValue);
				return;
			case scrPackage.TCOMPONENT__PROPERTY:
				getProperty().clear();
				getProperty().addAll((Collection)newValue);
				return;
			case scrPackage.TCOMPONENT__PROPERTIES:
				getProperties().clear();
				getProperties().addAll((Collection)newValue);
				return;
			case scrPackage.TCOMPONENT__SERVICE:
				setService((Tservice)newValue);
				return;
			case scrPackage.TCOMPONENT__REFERENCE:
				getReference().clear();
				getReference().addAll((Collection)newValue);
				return;
			case scrPackage.TCOMPONENT__IMPLEMENTATION:
				setImplementation((Timplementation)newValue);
				return;
			case scrPackage.TCOMPONENT__ANY:
				((FeatureMap.Internal)getAny()).set(newValue);
				return;
			case scrPackage.TCOMPONENT__ACTIVATE:
				setActivate((String)newValue);
				return;
			case scrPackage.TCOMPONENT__CONFIGURATION_PID:
				setConfigurationPid((String)newValue);
				return;
			case scrPackage.TCOMPONENT__CONFIGURATION_POLICY:
				setConfigurationPolicy((TconfigurationPolicy)newValue);
				return;
			case scrPackage.TCOMPONENT__DEACTIVATE:
				setDeactivate((String)newValue);
				return;
			case scrPackage.TCOMPONENT__ENABLED:
				setEnabled(((Boolean)newValue).booleanValue());
				return;
			case scrPackage.TCOMPONENT__FACTORY:
				setFactory((String)newValue);
				return;
			case scrPackage.TCOMPONENT__IMMEDIATE:
				setImmediate(((Boolean)newValue).booleanValue());
				return;
			case scrPackage.TCOMPONENT__MODIFIED:
				setModified((String)newValue);
				return;
			case scrPackage.TCOMPONENT__NAME:
				setName((String)newValue);
				return;
			case scrPackage.TCOMPONENT__ANY_ATTRIBUTE:
				((FeatureMap.Internal)getAnyAttribute()).set(newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case scrPackage.TCOMPONENT__GROUP:
				getGroup().clear();
				return;
			case scrPackage.TCOMPONENT__PROPERTY:
				getProperty().clear();
				return;
			case scrPackage.TCOMPONENT__PROPERTIES:
				getProperties().clear();
				return;
			case scrPackage.TCOMPONENT__SERVICE:
				setService((Tservice)null);
				return;
			case scrPackage.TCOMPONENT__REFERENCE:
				getReference().clear();
				return;
			case scrPackage.TCOMPONENT__IMPLEMENTATION:
				setImplementation((Timplementation)null);
				return;
			case scrPackage.TCOMPONENT__ANY:
				getAny().clear();
				return;
			case scrPackage.TCOMPONENT__ACTIVATE:
				unsetActivate();
				return;
			case scrPackage.TCOMPONENT__CONFIGURATION_PID:
				setConfigurationPid(CONFIGURATION_PID_EDEFAULT);
				return;
			case scrPackage.TCOMPONENT__CONFIGURATION_POLICY:
				unsetConfigurationPolicy();
				return;
			case scrPackage.TCOMPONENT__DEACTIVATE:
				unsetDeactivate();
				return;
			case scrPackage.TCOMPONENT__ENABLED:
				unsetEnabled();
				return;
			case scrPackage.TCOMPONENT__FACTORY:
				setFactory(FACTORY_EDEFAULT);
				return;
			case scrPackage.TCOMPONENT__IMMEDIATE:
				unsetImmediate();
				return;
			case scrPackage.TCOMPONENT__MODIFIED:
				setModified(MODIFIED_EDEFAULT);
				return;
			case scrPackage.TCOMPONENT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case scrPackage.TCOMPONENT__ANY_ATTRIBUTE:
				getAnyAttribute().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case scrPackage.TCOMPONENT__GROUP:
				return group != null && !group.isEmpty();
			case scrPackage.TCOMPONENT__PROPERTY:
				return !getProperty().isEmpty();
			case scrPackage.TCOMPONENT__PROPERTIES:
				return !getProperties().isEmpty();
			case scrPackage.TCOMPONENT__SERVICE:
				return service != null;
			case scrPackage.TCOMPONENT__REFERENCE:
				return reference != null && !reference.isEmpty();
			case scrPackage.TCOMPONENT__IMPLEMENTATION:
				return implementation != null;
			case scrPackage.TCOMPONENT__ANY:
				return any != null && !any.isEmpty();
			case scrPackage.TCOMPONENT__ACTIVATE:
				return isSetActivate();
			case scrPackage.TCOMPONENT__CONFIGURATION_PID:
				return CONFIGURATION_PID_EDEFAULT == null ? configurationPid != null : !CONFIGURATION_PID_EDEFAULT.equals(configurationPid);
			case scrPackage.TCOMPONENT__CONFIGURATION_POLICY:
				return isSetConfigurationPolicy();
			case scrPackage.TCOMPONENT__DEACTIVATE:
				return isSetDeactivate();
			case scrPackage.TCOMPONENT__ENABLED:
				return isSetEnabled();
			case scrPackage.TCOMPONENT__FACTORY:
				return FACTORY_EDEFAULT == null ? factory != null : !FACTORY_EDEFAULT.equals(factory);
			case scrPackage.TCOMPONENT__IMMEDIATE:
				return isSetImmediate();
			case scrPackage.TCOMPONENT__MODIFIED:
				return MODIFIED_EDEFAULT == null ? modified != null : !MODIFIED_EDEFAULT.equals(modified);
			case scrPackage.TCOMPONENT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case scrPackage.TCOMPONENT__ANY_ATTRIBUTE:
				return anyAttribute != null && !anyAttribute.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (group: ");
		result.append(group);
		result.append(", any: ");
		result.append(any);
		result.append(", activate: ");
		if (activateESet) result.append(activate); else result.append("<unset>");
		result.append(", configurationPid: ");
		result.append(configurationPid);
		result.append(", configurationPolicy: ");
		if (configurationPolicyESet) result.append(configurationPolicy); else result.append("<unset>");
		result.append(", deactivate: ");
		if (deactivateESet) result.append(deactivate); else result.append("<unset>");
		result.append(", enabled: ");
		if (enabledESet) result.append(enabled); else result.append("<unset>");
		result.append(", factory: ");
		result.append(factory);
		result.append(", immediate: ");
		if (immediateESet) result.append(immediate); else result.append("<unset>");
		result.append(", modified: ");
		result.append(modified);
		result.append(", name: ");
		result.append(name);
		result.append(", anyAttribute: ");
		result.append(anyAttribute);
		result.append(')');
		return result.toString();
	}

} //TcomponentImpl
